/*
  ==============================================================================

  This is an automatically generated file created by the Jucer!

  Creation date:  13 Nov 2010 7:26:58pm

  Be careful when adding custom code to these files, as only the code within
  the "//[xyz]" and "//[/xyz]" sections will be retained when the file is loaded
  and re-saved.

  Jucer version: 1.12

  ------------------------------------------------------------------------------

  The Jucer is part of the JUCE library - "Jules' Utility Class Extensions"
  Copyright 2004-6 by Raw Material Software ltd.

  ==============================================================================
*/

//[Headers] You can add your own extra header files here...
#include "synth.h"
//[/Headers]

#include "tabbed-editor.h"
#include "editor.h"
#include "about.h"


//[MiscUserDefs] You can add your own user definitions and misc code here...
//[/MiscUserDefs]

//==============================================================================
tabbed_editor::tabbed_editor (AudioProcessor *const ownerFilter)
    : AudioProcessorEditor(ownerFilter), kbd_button(0),
      midi_keyboard (0),
      tabbedEditor (0),
      comboBox (0),
      polytext (0)
{
    addAndMakeVisible (midi_keyboard = new MidiKeyboardComponent (midi_keyboard_state,
                                                                  MidiKeyboardComponent::horizontalKeyboard));
    midi_keyboard->setName (T("new component"));

    addAndMakeVisible (tabbedEditor = new TabbedComponent (TabbedButtonBar::TabsAtTop));
    tabbedEditor->setTabBarDepth (28);
    tabbedEditor->addTab (T("Parameters"), Colour (0xff272727), new editor (ownerFilter), true);
    tabbedEditor->addTab (T("About"), Colour (0xff272727), new about(), true);
    tabbedEditor->setCurrentTabIndex (0);

    addAndMakeVisible (comboBox = new PresetComboBox (T("new combo box")));
    comboBox->setEditableText (false);
    comboBox->setJustificationType (Justification::centred);
    comboBox->setTextWhenNothingSelected (String());
    comboBox->setTextWhenNoChoicesAvailable (T("(no choices)"));
    comboBox->addItem (T("Bass Drone 1"), 1);
    comboBox->addItem (T("Bass Drone 2"), 2);
    comboBox->addItem (T("Lead Swirl"), 3);
    comboBox->addItem (T("Preset X"), 4);
    comboBox->addItem (T("----"), 5);
    comboBox->addItem (T("Save"), 6);
    comboBox->addItem (T("Save As..."), 7);
    comboBox->addListener (this);

    addAndMakeVisible (polytext = new Label (T("new label"),
                                             String()));
    polytext->setFont (Font (15.0000f, Font::plain));
    polytext->setJustificationType (Justification::centredRight);
    polytext->setEditable (false, false, false);
    polytext->setColour (Label::textColourId, Colours::white);
    polytext->setColour (Label::outlineColourId, Colour (0xff0000));
    polytext->setColour (TextEditor::textColourId, Colours::black);
    polytext->setColour (TextEditor::backgroundColourId, Colour (0x0));


    //[UserPreSize]
    //[/UserPreSize]

    setSize (400, 576);

    //[Constructor] You can add your own custom stuff here..
    midi_keyboard_state.addListener((wolp*)ownerFilter);
	midi_keyboard->setKeyWidth(12);
	midi_keyboard->setColour(MidiKeyboardComponent::whiteNoteColourId, Colour(192, 192, 192));
	midi_keyboard->setColour(MidiKeyboardComponent::mouseOverKeyOverlayColourId, Colour(240, 240, 240));
	midi_keyboard->setColour(MidiKeyboardComponent::keyDownOverlayColourId, Colour(0, 0, 0));
	midi_keyboard->setColour(MidiKeyboardComponent::upDownButtonBackgroundColourId, Colour(192, 192, 192));
//	midi_keyboard->setVelocity(1.0, true);

//	comboBox->initItems();
	comboBox->setVisible(false);

#ifdef CONFIG_STANDALONE
    addAndMakeVisible (kbd_button = new KeyboardButton (String()));
    kbd_button->setColour (ToggleButton::textColourId, Colours::white);
    kbd_button->setBounds (2, getHeight()-20, getWidth()-4, 16);
#endif
    //[/Constructor]
}

tabbed_editor::~tabbed_editor()
{
    //[Destructor_pre]. You can add your own custom destruction code here..
    //[/Destructor_pre]

    deleteAndZero (midi_keyboard);
    deleteAndZero (tabbedEditor);
    deleteAndZero (comboBox);
    deleteAndZero (polytext);

    //[Destructor]. You can add your own custom destruction code here..
#ifdef CONFIG_STANDALONE
    deleteAndZero (kbd_button);
#endif
    //[/Destructor]
}

//==============================================================================
void tabbed_editor::paint (Graphics& g)
{
    //[UserPrePaint] Add your own custom painting code here..
    //[/UserPrePaint]

    g.fillAll (Colour (0xff404040));

    g.setGradientFill (ColourGradient (Colour (0xff505050),
                                       122.0f, (float) (-4),
                                       Colour (0xff303030),
                                       126.0f, 34.0f,
                                       false));
    g.fillPath (internalPath1);

    //[UserPaint] Add your own custom painting code here..
    //[/UserPaint]
}

void tabbed_editor::resized()
{
    midi_keyboard->setBounds (0, 520, 400, 56);
    tabbedEditor->setBounds (0, 0, 400, 520);
    comboBox->setBounds (396, -12, 104, 16);
    polytext->setBounds (328, 500, 72, 16);
    internalPath1.clear();
    internalPath1.startNewSubPath (0.0f, 32.0f);
    internalPath1.lineTo (0.0f, 0.0f);
    internalPath1.lineTo (400.0f, 0.0f);
    internalPath1.lineTo (400.0f, 32.0f);
    internalPath1.closeSubPath();

    //[UserResized] Add your own custom resize handling here..
    //[/UserResized]
}

void tabbed_editor::comboBoxChanged (ComboBox* comboBoxThatHasChanged)
{
    //[UsercomboBoxChanged_Pre]
    //[/UsercomboBoxChanged_Pre]

    if (comboBoxThatHasChanged == comboBox)
    {
        //[UserComboBoxCode_comboBox] -- add your combo box handling code here..
        //[/UserComboBoxCode_comboBox]
    }

    //[UsercomboBoxChanged_Post]
    //[/UsercomboBoxChanged_Post]
}



//[MiscUserCode] You can add your own definitions of your custom methods or any other code here...
//[/MiscUserCode]


//==============================================================================
#if 0
/*  -- Jucer information section --

    This is where the Jucer puts all of its metadata, so don't change anything in here!

BEGIN_JUCER_METADATA

<JUCER_COMPONENT documentType="Component" className="tabbed_editor" componentName=""
                 parentClasses="public AudioProcessorEditor" constructorParams="AudioProcessor *const ownerFilter"
                 variableInitialisers="AudioProcessorEditor(ownerFilter), kbd_button(0)"
                 snapPixels="4" snapActive="1" snapShown="0" overlayOpacity="0.330000013"
                 fixedSize="1" initialWidth="400" initialHeight="576">
  <BACKGROUND backgroundColour="ff404040">
    <PATH pos="0 0 100 100" fill="linear: 122 -4, 126 34, 0=ff505050, 1=ff303030"
          hasStroke="0" nonZeroWinding="1">s 0 32 l 0 0 l 400 0 l 400 32 x</PATH>
  </BACKGROUND>
  <GENERICCOMPONENT name="new component" id="bbb690ecc3998aec" memberName="midi_keyboard"
                    virtualName="" explicitFocusOrder="0" pos="0 520 400 56" class="MidiKeyboardComponent"
                    params="midi_keyboard_state,&#10;MidiKeyboardComponent::horizontalKeyboard"/>
  <TABBEDCOMPONENT name="tabbedEditor" id="eedf7b50f4218e4" memberName="tabbedEditor"
                   virtualName="" explicitFocusOrder="0" pos="0 0 400 520" orientation="top"
                   tabBarDepth="28" initialTab="0">
    <TAB name="Parameters" colour="ff272727" useJucerComp="1" contentClassName="asdf"
         constructorParams="ownerFilter" jucerComponentFile="editor.cpp"/>
    <TAB name="About" colour="ff272727" useJucerComp="1" contentClassName=""
         constructorParams="" jucerComponentFile="about.cpp"/>
  </TABBEDCOMPONENT>
  <COMBOBOX name="new combo box" id="dcc06fc0e979f2e7" memberName="comboBox"
            virtualName="PresetComboBox" explicitFocusOrder="0" pos="396 -12 104 16"
            editable="0" layout="36" items="Bass Drone 1&#10;Bass Drone 2&#10;Lead Swirl&#10;Preset X&#10;----&#10;Save&#10;Save As..."
            textWhenNonSelected="" textWhenNoItems="(no choices)"/>
  <LABEL name="new label" id="e5d0a1b78b69180a" memberName="polytext"
         virtualName="" explicitFocusOrder="0" pos="328 500 72 16" textCol="ffffffff"
         outlineCol="ff0000" edTextCol="ff000000" edBkgCol="0" labelText=""
         editableSingleClick="0" editableDoubleClick="0" focusDiscardsChanges="0"
         fontname="Default font" fontsize="15" bold="0" italic="0" justification="34"/>
</JUCER_COMPONENT>

END_JUCER_METADATA
*/
#endif

//==============================================================================
// Binary resources - be careful not to edit any of these sections!

// JUCER_RESOURCE: scratches_png, 19430, "../res/scratches.png"
static const unsigned char resource_tabbed_editor_scratches_png[] = { 137,80,78,71,13,10,26,10,0,0,0,13,73,72,68,82,0,0,1,44,0,0,0,180,8,0,0,0,0,11,84,78,51,0,0,0,1,115,82,71,66,0,174,206,28,233,0,0,0,
9,112,72,89,115,0,0,11,19,0,0,11,19,1,0,154,156,24,0,0,0,7,116,73,77,69,7,218,11,6,15,52,11,10,110,150,102,0,0,32,0,73,68,65,84,120,94,116,189,59,150,228,186,206,117,59,43,199,129,207,70,202,145,191,28,
180,0,199,128,175,107,168,145,244,177,141,107,0,140,200,218,231,251,53,246,163,50,74,33,145,32,176,176,240,32,243,207,127,145,197,186,146,115,57,101,161,4,16,88,120,189,119,89,32,82,125,199,220,235,225,
129,19,56,0,129,7,30,30,30,231,239,101,132,176,34,157,231,14,80,122,40,253,217,176,238,103,139,92,215,59,239,246,2,72,65,58,69,143,65,169,68,223,193,41,149,204,107,215,69,10,163,72,100,4,8,176,226,123,
59,120,56,225,4,200,138,68,41,102,6,30,255,126,250,231,59,178,248,215,103,178,64,127,254,73,189,251,251,5,229,186,139,68,164,122,224,161,100,109,39,100,61,157,117,125,30,229,60,251,200,204,33,60,100,33,
230,239,215,117,166,109,101,196,186,99,177,245,94,239,101,4,120,145,107,35,114,109,0,65,139,7,210,107,102,164,236,129,158,23,126,23,226,124,100,245,222,253,169,18,25,69,42,251,59,2,139,89,212,150,20,30,
40,149,235,202,121,216,218,235,142,239,147,69,194,186,67,249,253,171,185,100,127,254,171,28,81,41,209,187,101,225,161,89,130,148,209,58,101,33,140,80,138,244,0,39,144,17,94,70,156,229,91,123,109,47,227,
204,136,178,226,189,140,194,0,158,237,207,94,92,239,29,8,222,221,154,194,226,178,74,209,243,81,210,122,54,154,245,247,210,127,116,65,0,22,78,245,184,140,250,40,74,203,29,29,137,224,179,56,178,240,74,198,
44,192,121,46,227,51,224,254,240,163,123,255,122,171,254,252,243,145,20,180,50,84,226,207,149,235,202,179,60,57,11,102,212,175,135,56,225,31,219,195,161,12,234,189,207,171,193,131,181,149,178,122,239,
231,38,88,123,237,181,241,88,87,178,246,186,222,221,147,110,227,16,249,25,169,72,143,143,62,124,230,131,159,33,200,42,69,234,179,118,128,151,133,198,36,122,136,99,131,253,13,18,89,136,35,173,5,219,225,
185,159,61,195,109,209,174,187,18,104,133,111,123,229,151,176,126,219,225,44,140,114,244,135,4,175,70,155,58,22,225,208,19,104,157,114,202,202,250,175,62,54,225,101,80,88,189,236,197,94,55,60,119,248,
179,157,88,155,158,248,17,88,202,42,91,4,253,74,4,6,189,62,94,86,57,74,99,149,202,94,41,14,168,121,181,172,213,88,231,69,27,192,140,83,70,97,245,145,85,11,127,132,241,149,38,253,153,200,143,160,96,76,
83,144,63,141,218,9,200,165,94,198,36,165,68,43,128,68,40,80,180,238,120,171,66,64,20,142,34,60,162,37,20,53,127,51,207,47,170,127,218,123,237,219,137,136,253,172,231,242,2,36,120,146,5,27,146,84,223,
106,97,56,32,135,164,168,194,129,200,24,13,75,34,73,34,84,194,61,27,228,99,52,48,27,223,99,100,37,2,34,176,40,8,115,189,120,38,16,129,251,141,131,136,90,95,193,108,95,202,68,219,63,31,57,38,32,83,127,
254,11,140,144,143,216,31,26,76,214,110,227,104,52,112,40,224,107,206,206,44,231,168,80,122,181,13,127,49,139,234,193,123,172,237,177,182,222,155,112,10,123,246,172,226,187,97,220,216,0,179,44,90,85,140,
234,127,90,249,45,240,106,141,255,2,147,247,243,203,10,139,99,23,99,198,98,60,39,20,237,117,126,227,159,7,78,229,87,143,214,30,151,208,32,125,240,78,214,62,3,253,167,191,191,1,101,136,212,27,91,100,2,
91,233,133,44,176,128,240,58,223,130,153,96,226,200,1,202,210,195,130,244,136,181,231,237,101,192,139,12,15,66,73,174,192,169,151,122,251,57,107,20,92,100,37,41,83,25,33,136,20,129,21,196,113,174,64,89,
144,31,208,183,82,171,57,145,193,48,30,71,45,216,28,216,138,112,2,163,82,237,102,6,246,133,211,134,14,87,130,243,136,132,16,32,194,131,103,196,210,52,64,249,31,190,147,119,148,98,159,117,147,193,99,80,
22,101,78,132,133,197,74,96,109,37,70,165,87,99,168,69,246,92,240,70,217,59,64,78,188,101,133,17,190,110,188,146,189,120,238,116,192,98,109,216,202,245,238,181,142,194,140,30,165,90,245,123,101,123,118,
137,23,225,68,50,14,161,44,60,52,235,159,202,32,161,50,127,147,173,102,52,77,62,218,21,68,226,81,73,250,179,145,225,237,75,163,48,246,218,7,180,137,86,33,18,241,54,48,254,135,207,53,104,208,146,123,73,
66,121,109,25,225,84,202,2,15,54,107,179,219,40,211,195,120,46,26,108,229,238,148,5,188,225,0,86,86,64,99,241,29,44,131,135,251,9,9,139,135,155,135,157,235,202,117,53,182,147,130,200,81,52,171,227,248,
178,5,22,158,52,16,157,245,13,130,116,24,93,243,24,51,251,222,209,242,174,12,124,158,86,217,158,35,86,220,101,171,210,91,25,221,139,125,52,229,208,111,0,148,92,77,11,254,252,127,108,39,104,145,250,179,
65,57,214,203,199,47,89,12,30,157,111,55,21,51,8,217,115,15,141,34,188,242,67,37,98,109,89,165,67,224,33,123,174,92,247,115,243,92,185,118,67,106,227,214,130,173,38,118,127,115,168,67,233,255,102,90,30,
52,37,205,225,0,196,12,17,98,212,34,103,152,243,215,205,151,61,156,144,241,220,79,115,255,194,160,222,221,216,250,94,111,179,27,189,187,125,44,36,172,43,63,146,249,217,23,209,26,103,16,27,148,226,66,240,
182,1,176,200,128,36,96,209,203,166,2,97,68,201,234,194,140,168,162,20,230,225,4,129,199,186,68,12,155,40,189,129,173,59,238,128,87,151,246,205,222,123,161,141,174,107,228,147,137,16,184,200,36,3,72,148,
73,34,63,222,73,1,225,71,229,132,71,184,139,12,143,64,137,142,172,230,191,141,119,225,69,80,65,22,55,59,33,41,179,39,176,155,128,12,54,187,90,16,151,250,209,36,162,101,69,220,203,245,231,255,187,82,169,
119,195,218,67,201,58,250,249,120,195,166,68,199,197,41,81,243,69,27,162,223,228,190,99,157,178,195,2,27,132,189,199,249,94,185,216,248,115,63,151,181,173,122,176,246,226,122,233,216,112,109,148,235,142,
118,140,240,139,90,50,158,43,102,0,30,222,148,125,148,150,148,77,68,170,143,144,116,254,215,42,69,89,89,229,240,40,11,189,23,249,81,187,79,136,57,236,152,95,234,188,174,108,3,216,252,236,36,201,13,236,
213,239,219,164,88,188,92,122,243,237,153,240,204,168,73,72,136,227,207,89,111,41,161,74,213,134,227,224,248,56,172,135,82,24,23,235,222,190,184,30,94,234,125,88,132,59,236,43,175,13,44,180,1,238,240,
196,6,195,103,212,130,161,75,222,254,75,161,114,19,68,21,58,49,127,56,173,85,9,205,23,91,86,4,225,65,100,81,192,237,8,74,118,3,84,248,10,88,150,237,24,48,37,36,43,115,94,12,151,1,27,54,252,0,44,137,165,
254,19,9,74,54,183,204,46,93,234,27,55,61,22,104,227,84,122,9,165,93,151,37,237,136,214,24,107,60,30,134,1,126,149,161,178,52,194,185,225,186,239,72,246,218,172,96,55,232,188,237,20,81,82,10,140,148,242,
109,113,9,53,100,208,172,199,91,191,50,192,112,75,37,233,56,145,132,148,102,6,106,203,29,89,125,190,104,73,66,20,188,88,86,37,144,138,219,137,171,212,235,146,145,122,89,108,53,167,73,214,47,226,194,159,
255,250,195,197,123,113,84,52,5,239,214,187,157,122,247,164,16,218,128,243,51,0,189,92,100,235,168,215,123,211,73,9,11,217,55,101,115,112,58,215,13,60,220,147,163,80,39,46,218,188,3,189,251,64,246,39,
204,235,245,160,141,108,220,109,219,52,80,88,71,241,3,23,7,27,122,70,126,24,71,158,57,174,171,227,180,25,255,33,175,208,19,195,120,174,212,187,245,94,67,225,212,110,69,67,87,215,198,159,173,252,243,15,
144,122,185,192,130,53,8,214,17,236,9,58,193,121,174,182,140,121,227,96,153,146,117,165,176,231,194,234,221,141,239,223,123,16,198,179,157,208,203,101,132,63,55,60,251,140,249,189,82,159,228,3,199,9,181,
118,183,4,154,74,31,160,118,160,172,26,176,202,62,137,167,143,167,158,203,15,209,82,179,128,247,74,175,156,212,76,15,46,123,136,244,146,188,67,177,90,66,119,229,111,105,3,122,47,139,63,255,12,150,118,
140,241,94,233,177,216,178,122,91,124,58,201,185,207,26,126,115,80,131,135,216,39,172,121,104,47,241,201,55,189,187,65,180,114,109,229,201,7,38,94,22,139,47,3,110,60,231,72,168,53,69,201,80,133,214,214,
240,64,233,132,72,165,211,145,247,215,243,124,174,17,174,114,150,108,34,10,165,90,248,136,206,153,181,168,38,219,117,102,58,232,62,142,14,175,92,87,58,225,63,36,43,197,27,64,113,65,233,66,196,123,99,60,
234,216,173,223,63,175,223,130,212,102,29,53,104,66,100,200,185,199,75,196,234,143,216,30,129,71,188,106,179,125,235,113,3,158,172,181,247,197,202,37,120,91,82,13,43,153,43,27,168,7,99,21,120,68,85,16,
82,58,229,164,76,96,224,173,30,32,211,25,36,60,17,14,254,145,21,219,129,133,240,108,217,154,17,144,198,152,54,40,47,96,129,94,83,10,93,222,209,81,160,235,165,80,253,160,188,100,47,238,8,140,5,121,145,
218,101,97,55,182,149,18,126,30,201,24,72,210,100,12,67,80,148,149,140,192,239,229,32,93,96,89,105,30,64,72,151,229,98,197,125,67,21,203,239,245,94,194,184,184,128,11,75,79,2,220,221,217,174,126,81,66,
6,134,2,129,36,16,237,214,58,192,34,14,165,201,50,156,118,152,218,112,160,51,83,45,37,215,213,158,1,71,89,181,100,217,95,14,239,135,229,139,182,4,149,14,105,21,0,41,50,183,83,216,143,161,55,235,190,162,
58,121,116,129,94,96,81,14,176,210,73,149,123,184,141,33,42,123,149,120,51,169,55,203,200,23,51,194,31,98,227,235,133,55,67,185,34,0,41,51,195,55,155,32,55,201,126,2,72,15,79,50,81,174,71,177,4,30,84,
136,202,214,18,119,7,98,172,61,193,200,227,156,156,40,249,74,70,161,178,134,37,180,67,135,8,112,131,100,175,36,10,203,4,80,128,44,47,130,229,14,78,44,222,5,235,18,202,204,43,21,137,63,57,250,209,9,23,
163,254,252,99,225,245,94,0,246,112,97,157,246,236,63,10,11,214,77,145,120,76,110,18,189,220,209,250,45,44,212,233,21,123,54,30,50,40,120,55,235,202,38,158,147,178,247,70,145,126,113,199,243,112,114,193,
214,89,228,117,71,187,21,14,226,15,238,228,1,252,78,197,40,149,159,72,144,95,30,244,252,124,126,84,122,87,74,172,29,131,63,176,213,129,78,32,235,36,169,215,4,131,205,219,187,10,225,39,111,234,129,222,
203,138,247,7,60,236,122,33,225,190,161,86,72,81,55,47,143,160,156,59,202,250,97,97,254,38,202,189,99,53,168,144,177,32,195,48,110,40,39,40,146,189,184,147,90,218,190,179,24,154,188,120,137,8,224,98,181,
103,35,201,201,53,33,118,224,9,153,57,216,60,222,184,101,37,145,101,134,192,141,192,141,73,16,69,192,39,250,93,163,105,195,251,118,128,103,84,81,230,177,175,221,107,84,44,50,238,184,113,162,111,229,133,
36,185,42,95,173,114,181,18,135,22,55,5,215,159,255,178,238,240,234,80,249,185,32,215,149,179,230,179,246,239,6,39,188,190,235,57,147,144,61,23,239,134,117,63,219,139,102,85,123,156,101,187,205,81,193,
206,242,46,246,144,51,158,187,85,245,183,251,3,240,167,163,44,0,229,172,46,109,254,34,59,41,245,203,22,189,166,132,67,29,42,248,137,205,102,20,107,227,132,210,159,203,202,138,151,41,223,220,225,177,246,
201,70,234,237,127,253,185,235,189,107,24,103,91,143,21,233,63,206,85,170,124,136,151,218,48,238,252,173,78,139,18,176,221,69,56,40,9,247,228,51,166,55,90,139,128,75,143,1,97,218,202,212,86,167,131,94,
189,153,18,182,2,88,251,90,176,19,162,238,32,27,183,51,73,53,135,198,189,182,32,83,106,119,246,169,121,165,210,49,79,40,232,172,159,168,34,140,114,47,69,36,227,191,170,70,187,110,38,82,105,241,199,13,
20,92,119,56,238,236,199,195,183,83,150,181,157,188,164,220,82,237,226,42,240,180,188,129,44,167,140,85,127,254,153,26,26,193,98,175,235,189,128,20,239,86,43,88,120,8,43,251,148,73,62,132,143,197,61,108,
186,227,66,235,82,42,227,8,198,25,172,189,24,254,49,87,215,27,24,226,11,180,135,111,121,125,226,103,37,254,171,54,67,135,235,77,177,254,174,164,54,180,53,3,107,216,1,88,220,31,182,5,172,61,92,173,186,
110,57,101,161,0,127,174,156,31,213,121,159,134,209,68,121,172,35,101,149,63,41,82,242,8,156,173,235,221,192,203,251,94,222,225,89,56,144,65,56,56,44,232,177,72,172,139,50,11,224,121,41,195,34,218,252,
63,147,134,87,108,246,158,228,142,96,45,72,143,80,133,129,50,36,228,35,170,15,81,162,3,209,83,220,3,16,20,19,15,134,225,39,165,44,87,206,144,34,200,206,239,0,236,205,97,91,0,155,34,2,175,188,95,66,35,
194,128,85,59,207,27,112,67,40,37,34,213,214,145,175,72,39,222,245,231,159,247,20,50,98,221,15,92,240,110,38,13,216,208,229,245,94,157,223,110,46,126,86,146,166,188,179,26,232,229,74,60,214,94,215,232,
6,31,29,28,6,13,64,231,119,160,43,86,74,166,32,169,236,162,247,71,57,70,21,70,183,122,52,214,128,229,52,166,144,237,203,242,188,109,10,249,201,23,4,63,233,155,236,196,206,248,194,153,228,239,75,137,236,
185,206,243,62,65,216,187,101,177,174,255,88,189,29,207,189,236,34,245,94,108,165,148,94,38,40,75,167,195,51,37,16,76,17,199,195,168,244,86,184,213,139,171,68,190,54,215,4,229,118,6,163,153,75,35,45,30,
109,124,49,211,177,49,23,101,164,176,32,17,178,24,207,237,213,56,127,96,193,41,148,22,51,153,176,147,126,22,64,87,45,56,118,13,207,253,161,18,73,86,186,81,134,7,196,254,37,202,68,176,46,98,231,34,155,
203,103,143,78,219,85,144,63,149,151,87,57,182,183,147,122,193,72,44,69,134,1,15,212,97,239,225,173,171,132,121,120,132,121,248,195,10,238,116,7,18,127,139,69,2,139,149,92,204,53,182,217,178,138,114,64,
139,131,79,17,43,251,193,34,179,250,143,163,22,222,254,48,156,132,170,192,43,194,128,208,20,244,84,38,63,51,211,135,64,8,101,194,98,7,1,43,23,32,161,8,62,29,6,95,103,155,90,144,59,95,166,80,113,97,185,
28,20,101,42,227,53,126,16,245,230,195,211,154,121,93,148,156,130,88,170,76,219,148,121,24,96,61,100,197,40,177,168,242,226,185,209,3,93,12,125,110,246,150,179,246,197,158,4,225,98,229,102,165,50,93,85,
114,111,77,189,208,193,19,109,196,36,161,62,22,212,211,136,232,130,87,204,58,21,64,24,194,80,179,155,12,235,229,124,143,136,3,118,246,195,55,40,128,75,155,133,101,63,243,35,164,96,133,3,82,54,166,236,
182,126,145,22,236,86,143,50,202,118,248,159,255,42,189,147,246,1,254,116,149,127,34,253,33,236,88,56,225,113,220,205,88,115,119,193,120,89,229,186,107,58,46,148,205,195,135,227,76,77,162,109,204,187,
80,192,120,185,174,164,50,112,195,215,197,53,82,124,150,132,182,112,25,191,110,111,231,59,157,42,223,111,161,84,174,169,91,30,220,77,248,164,20,252,219,128,242,189,188,200,249,34,202,9,15,160,57,2,235,
98,2,135,31,16,108,2,92,170,187,27,22,194,87,115,139,68,202,9,93,149,52,235,113,51,55,87,97,218,170,36,185,194,194,73,135,244,209,226,142,134,55,234,244,89,242,18,23,41,94,115,15,143,174,164,210,185,205,
52,80,164,137,179,174,88,4,238,29,81,119,136,220,116,63,93,202,204,130,140,170,177,181,102,224,90,144,43,39,7,236,30,61,144,4,220,118,118,174,192,100,231,195,185,180,202,18,104,212,24,28,116,188,245,71,
107,191,16,150,161,245,3,68,142,237,26,207,219,138,23,155,161,56,227,248,74,129,244,8,164,168,168,167,12,171,151,76,30,72,63,209,255,10,32,214,2,34,125,47,114,35,184,58,75,98,122,237,166,130,88,164,181,
37,135,52,209,191,42,133,66,233,99,132,81,129,245,234,205,130,153,123,100,34,129,9,195,230,135,190,14,19,6,32,98,1,178,60,64,235,4,4,132,217,44,8,238,72,185,51,92,99,21,195,141,137,21,128,7,182,181,19,
47,201,246,207,2,225,196,42,44,216,251,180,145,25,101,66,28,45,71,36,23,47,111,42,225,178,176,94,64,246,135,29,61,205,62,63,67,126,38,141,3,185,220,31,89,189,119,117,93,244,134,104,12,145,165,207,116,
243,95,235,234,137,213,212,65,146,180,132,8,80,143,41,85,212,12,176,223,167,244,67,5,1,182,36,130,128,140,128,24,170,232,17,129,148,114,170,60,191,58,54,230,76,38,238,251,19,72,167,156,199,176,199,127,
46,72,30,231,162,0,247,0,33,168,245,134,65,142,164,207,35,47,118,23,55,138,232,248,70,208,32,249,172,125,3,172,228,238,33,239,137,231,128,29,92,89,182,161,135,31,184,179,179,4,229,133,32,245,107,93,155,
140,70,199,178,101,46,251,252,216,133,193,180,18,73,102,215,54,122,178,185,34,252,119,180,112,36,225,114,157,198,156,156,56,78,76,116,4,76,118,76,144,24,114,226,89,129,135,59,229,16,185,43,235,226,207,
63,67,151,158,139,244,226,189,235,221,154,28,48,128,178,221,241,113,201,156,31,108,88,217,52,160,250,179,23,251,67,91,160,145,113,180,27,152,230,152,252,4,48,223,94,181,126,98,54,186,194,47,50,170,126,
163,209,121,233,254,162,5,254,92,244,195,231,171,235,151,136,254,190,214,69,122,157,82,74,205,2,103,119,222,28,142,199,76,20,229,218,39,53,195,233,12,154,180,136,255,249,211,141,27,193,248,194,53,53,88,
165,44,156,89,134,145,213,8,174,255,223,165,80,32,253,185,161,222,173,247,174,78,67,139,247,119,123,109,59,212,178,208,183,188,15,204,112,219,202,250,250,54,191,122,140,231,242,233,127,9,29,143,169,119,
154,161,230,63,57,247,127,150,233,95,87,215,99,189,107,169,6,199,227,43,53,61,116,125,219,204,186,127,234,168,208,159,59,214,213,178,229,39,222,183,30,194,113,184,202,216,183,29,152,42,34,122,36,153,159,
233,252,246,185,6,47,111,250,179,3,108,43,119,216,141,214,226,125,55,47,92,217,97,87,26,76,75,80,51,34,7,162,136,204,180,110,5,249,84,83,251,249,77,70,219,250,82,9,133,167,53,186,175,188,4,176,200,76,
50,71,86,252,191,100,229,86,20,221,236,24,4,152,3,37,55,29,93,3,68,138,116,139,201,207,110,201,140,216,56,47,46,44,234,103,237,139,203,79,4,86,206,131,1,158,96,32,12,178,9,4,227,120,90,249,69,100,189,
93,72,222,13,154,217,78,53,217,107,95,242,43,91,0,18,138,242,176,71,41,136,86,172,110,25,147,20,34,81,102,175,235,248,107,34,170,72,98,88,40,145,17,157,227,147,125,45,238,131,229,252,63,37,133,168,160,
44,74,52,100,68,129,187,159,12,124,86,39,16,123,194,15,238,67,90,204,234,113,17,220,219,154,215,253,220,188,105,136,242,21,246,18,126,181,181,46,101,245,2,116,174,137,67,105,16,47,202,68,228,133,179,85,
93,206,88,146,7,193,218,190,201,172,84,38,136,124,133,178,136,43,53,5,83,143,160,210,70,139,38,151,37,178,107,47,2,198,143,43,199,228,143,255,151,40,247,4,44,55,91,254,113,197,45,185,133,127,84,183,7,
219,79,41,65,18,110,64,86,16,148,194,205,34,201,12,249,249,202,29,129,59,241,132,81,182,11,231,193,235,129,112,126,106,237,21,164,103,220,171,29,122,244,247,76,22,62,211,5,32,115,242,26,185,147,197,139,
212,229,3,11,41,220,111,168,197,234,212,137,99,43,197,11,112,37,233,175,119,200,127,204,80,116,181,217,212,170,75,90,199,37,45,160,121,99,119,155,57,148,148,120,55,51,4,96,132,252,93,4,13,127,171,233,
195,186,59,217,52,159,74,96,153,120,166,217,43,168,112,135,36,132,153,23,56,200,219,134,2,160,171,110,15,155,174,175,91,44,2,110,222,69,253,36,108,98,177,188,174,8,235,126,18,156,93,22,171,228,100,63,
74,99,213,141,47,108,117,163,80,227,64,166,10,192,110,109,238,140,165,34,142,193,174,36,61,238,26,73,133,135,19,62,109,1,25,39,77,202,23,229,25,117,104,223,222,132,212,146,134,56,240,146,61,40,107,183,
65,134,195,246,5,98,71,76,228,77,32,207,110,178,160,156,226,62,124,78,253,215,117,244,34,60,170,249,29,222,85,183,107,20,51,41,191,111,2,158,251,38,127,180,5,92,113,23,169,21,166,130,0,35,67,119,123,170,
114,29,160,202,243,46,186,191,38,83,224,194,121,41,120,30,83,178,116,97,98,11,237,55,243,26,106,248,76,217,106,124,97,200,83,8,165,242,120,217,126,114,35,99,10,2,107,251,73,171,177,172,146,138,140,155,
118,132,171,39,14,117,79,154,239,0,189,156,114,194,21,158,132,83,120,128,87,187,144,36,236,232,5,229,12,202,79,213,45,207,83,227,45,96,17,119,5,254,99,110,206,194,201,84,110,133,129,17,209,42,79,153,121,
102,12,13,34,249,242,173,125,52,199,234,37,108,7,150,215,21,175,162,153,167,22,74,77,167,12,190,222,107,130,33,31,207,149,83,218,1,80,42,199,252,17,179,42,72,135,186,116,25,84,211,84,52,5,61,165,184,103,
52,250,8,233,115,77,175,152,117,1,212,58,47,82,118,86,155,82,121,183,227,80,157,176,165,77,197,108,28,199,130,43,9,223,128,1,63,21,129,176,138,181,64,239,10,35,188,3,83,171,164,162,221,89,158,87,124,108,
69,192,75,38,241,222,174,240,149,229,201,186,112,176,151,124,47,114,165,94,209,75,179,243,214,246,201,170,135,31,163,230,196,8,180,47,197,7,247,91,227,0,210,121,128,2,89,19,133,79,13,57,163,1,93,153,140,
203,167,161,74,71,90,229,25,230,81,70,240,193,76,192,57,141,119,14,234,142,36,9,208,195,85,238,80,55,11,47,66,233,17,212,243,99,78,216,21,76,124,117,183,238,94,129,91,37,150,138,180,51,154,193,46,90,197,
128,11,144,239,8,91,177,221,66,108,123,89,176,151,131,173,75,121,165,222,108,238,29,230,61,188,248,106,70,255,1,107,86,1,238,148,53,61,116,252,248,22,110,111,225,149,183,223,234,112,31,137,41,60,59,16,
7,213,243,24,149,19,158,213,212,250,183,180,218,208,203,26,204,48,172,66,8,140,196,238,130,224,21,161,157,97,142,81,46,236,254,243,207,84,90,38,151,61,37,98,166,216,1,57,42,96,113,196,244,81,177,14,131,
102,155,74,229,186,195,99,98,3,189,108,148,179,101,10,101,39,185,62,28,123,232,243,72,44,199,236,232,156,213,44,75,191,150,162,235,0,35,182,142,150,62,53,100,35,88,123,62,228,20,47,99,30,123,16,242,196,
44,78,208,37,111,171,97,239,222,221,195,69,106,192,198,43,245,94,6,117,198,175,151,237,84,254,36,15,171,69,110,164,21,198,11,77,181,27,66,146,191,212,183,181,234,88,72,35,116,116,82,107,133,147,105,161,
46,213,229,138,6,129,149,172,29,14,207,242,238,46,120,142,102,52,123,107,82,133,67,101,171,133,218,222,44,250,77,222,172,27,232,113,69,175,35,217,9,198,206,214,71,108,21,240,37,107,128,58,49,215,233,221,
194,113,107,236,26,152,12,35,168,150,85,27,98,25,92,47,133,193,50,252,37,175,155,42,227,199,117,63,219,159,118,10,10,163,124,59,224,66,93,216,19,142,29,38,253,107,24,244,36,190,221,166,190,137,88,4,233,
232,122,93,23,34,95,184,78,225,112,239,7,32,184,107,158,244,201,71,181,77,14,200,123,15,59,179,84,80,65,21,184,131,123,120,16,238,48,109,143,241,43,130,214,60,176,87,56,145,71,88,142,37,218,212,49,162,
192,204,194,6,82,202,166,159,20,188,151,168,156,188,202,234,129,141,226,198,223,240,215,138,31,50,80,93,15,222,82,14,11,47,239,101,48,148,148,101,180,69,218,39,229,113,228,101,97,92,73,174,213,112,193,
242,141,211,187,15,42,95,37,98,41,55,140,110,238,255,209,140,228,227,19,35,129,8,169,90,128,14,52,129,207,172,0,231,193,195,233,26,50,126,190,215,4,66,122,155,56,39,83,138,50,164,26,6,65,57,24,229,158,
21,128,135,145,74,68,233,165,35,5,222,158,91,153,200,224,242,240,7,130,231,86,236,48,126,88,92,192,29,205,168,62,210,158,8,93,153,229,82,247,35,13,110,14,103,16,10,239,78,165,147,235,211,253,176,104,239,
9,236,87,201,190,222,143,46,174,255,209,140,35,248,243,149,132,134,89,49,252,103,208,32,137,10,223,17,205,59,138,84,180,18,58,107,59,18,236,1,191,179,31,42,72,50,60,195,218,218,162,72,202,77,17,224,95,
22,177,149,136,36,62,37,212,76,39,9,113,25,226,226,197,41,126,170,61,85,113,134,87,30,221,202,88,105,101,233,100,251,146,131,91,237,161,142,194,139,71,46,64,165,45,171,107,237,178,212,187,180,19,72,189,
141,95,44,8,223,207,243,183,102,72,202,95,36,180,175,36,105,15,12,69,208,38,248,171,134,236,199,110,164,21,4,55,37,176,28,153,251,105,94,233,204,100,107,85,153,75,86,78,22,230,4,88,53,112,30,70,220,251,
177,148,144,203,79,136,158,229,239,74,174,21,158,250,105,109,201,33,53,89,214,188,195,16,42,240,112,209,11,254,69,249,163,253,100,25,87,70,106,31,107,202,155,12,231,234,172,214,197,123,129,50,197,6,194,
247,254,165,25,143,211,177,231,239,71,2,26,214,126,218,106,205,170,112,203,207,251,35,129,149,196,232,116,9,50,123,167,5,48,46,56,199,138,155,65,80,97,84,6,83,10,129,217,239,2,237,215,101,77,107,5,92,
113,131,163,12,207,184,55,149,27,176,31,128,214,71,161,158,126,180,5,146,214,59,211,176,78,111,142,199,228,179,200,0,93,232,156,7,144,171,22,60,109,98,122,83,55,122,223,209,118,22,44,2,252,201,100,52,
174,227,63,193,231,153,173,167,222,165,158,4,2,123,59,46,25,134,224,115,95,183,31,1,13,166,85,253,20,13,173,13,102,157,227,148,253,19,194,67,147,142,194,172,213,68,169,124,223,192,65,73,38,182,130,245,
24,34,240,98,101,239,183,251,9,63,34,152,193,22,138,50,202,146,114,66,148,5,241,13,163,196,183,154,41,194,42,135,48,43,189,116,191,27,118,32,92,47,11,94,246,158,187,215,238,221,190,196,134,69,18,137,50,
202,58,151,117,184,193,199,218,122,175,152,80,196,253,191,53,228,157,202,108,191,146,9,159,92,155,67,72,109,219,52,82,80,78,152,211,115,86,150,168,222,204,152,41,117,132,122,109,169,232,93,132,138,155,
184,239,178,116,7,99,147,4,138,159,213,230,229,103,245,33,80,22,89,174,44,9,179,240,126,29,227,232,148,151,82,72,153,168,178,173,158,76,34,137,75,44,224,93,5,251,226,185,88,172,100,173,197,110,171,105,
205,216,136,137,75,58,180,213,56,212,73,65,120,128,121,201,18,88,223,26,242,138,131,157,26,245,105,200,84,2,217,60,88,73,151,34,83,67,157,163,67,67,243,242,19,231,22,20,174,67,178,83,217,221,222,74,167,
3,141,206,139,212,56,219,178,245,179,131,196,153,157,159,106,21,19,233,4,74,44,3,31,237,107,221,210,112,93,154,76,38,228,226,37,5,34,61,209,70,190,47,216,164,93,112,11,113,125,138,46,61,233,5,233,152,
125,232,72,38,10,117,85,85,3,239,1,224,150,108,102,3,246,128,84,120,175,148,206,242,125,230,220,223,105,87,216,255,239,64,161,188,45,202,58,87,29,166,142,127,134,139,190,73,42,85,153,175,169,140,21,190,
10,247,8,203,199,183,156,101,236,159,142,107,127,37,104,19,37,70,153,14,56,226,225,168,117,43,57,43,51,166,39,164,235,83,31,156,249,81,234,226,104,189,249,22,59,187,201,252,220,17,83,175,114,34,38,216,
83,47,66,5,54,221,233,131,73,21,184,235,111,152,148,202,82,82,226,109,19,35,170,84,118,12,73,175,93,111,87,26,179,54,10,107,130,100,222,92,200,168,153,195,166,123,180,89,87,25,225,187,165,242,136,90,187,
4,190,43,248,153,217,221,121,30,43,204,9,207,104,85,238,37,137,6,247,104,31,241,49,217,68,7,99,26,55,58,138,141,204,140,120,181,96,115,103,186,82,159,229,88,64,184,192,35,194,157,208,169,66,143,121,36,
17,57,134,18,150,10,48,207,23,196,225,16,153,33,232,181,132,193,39,56,106,171,65,96,145,223,148,82,121,22,142,7,25,29,255,68,29,119,156,160,220,74,116,217,91,230,225,172,203,136,157,202,237,9,241,144,
206,159,127,48,168,228,91,245,34,123,207,18,62,125,167,129,211,27,102,122,103,60,61,238,60,139,221,200,42,122,235,225,41,87,37,154,42,86,252,234,172,4,214,22,83,136,11,38,138,86,126,98,227,116,154,31,
165,160,219,77,186,148,165,148,197,167,175,50,57,11,229,221,214,150,243,225,87,241,191,175,20,100,183,133,151,85,122,8,139,222,202,149,250,108,120,100,163,247,194,102,55,174,222,233,16,158,51,9,194,249,
15,132,135,5,101,77,59,82,144,101,85,73,184,194,138,240,8,207,66,132,107,98,186,158,151,143,115,86,15,103,81,228,234,170,92,7,94,15,194,16,203,14,130,56,113,145,16,120,244,215,90,69,104,27,87,255,157,
0,100,69,235,52,223,157,204,163,212,3,231,192,240,233,252,91,54,57,55,233,243,135,158,85,179,36,23,101,186,140,176,224,154,168,140,68,41,171,199,34,60,158,203,106,187,42,23,225,194,9,202,254,147,30,101,
120,80,105,69,14,84,150,149,44,250,191,196,192,122,210,155,246,63,74,63,158,8,102,93,173,222,86,233,30,108,79,40,200,117,93,221,160,234,81,31,106,116,26,247,70,43,28,15,153,7,159,254,228,132,236,170,129,
123,129,187,23,197,224,114,75,66,223,193,140,100,102,35,31,31,121,230,172,72,75,139,112,43,42,81,244,153,2,164,184,146,213,13,233,80,86,219,139,181,41,139,178,226,178,120,172,202,188,242,249,33,188,221,
92,246,240,58,18,37,44,163,115,27,14,244,158,120,208,12,115,214,75,237,74,206,228,20,236,52,111,103,153,137,214,5,45,207,188,175,107,75,191,186,11,22,167,22,9,200,233,194,99,163,57,96,137,10,146,114,139,
152,0,37,131,164,227,96,144,224,69,144,57,142,28,24,15,115,148,76,103,41,230,131,98,69,165,82,164,151,103,81,222,179,217,92,48,187,18,186,83,224,229,89,22,214,176,223,61,153,251,231,144,130,79,48,99,41,
210,212,162,106,176,139,129,211,222,102,149,234,225,164,67,96,112,146,168,61,162,208,240,247,100,39,88,177,110,243,192,220,120,170,222,114,95,176,118,83,143,126,86,127,211,9,62,254,208,141,222,215,17,
49,101,207,40,249,171,158,83,39,99,116,157,151,127,20,171,49,146,163,88,35,166,175,45,108,161,212,235,30,163,12,185,206,13,173,133,111,56,236,149,23,123,67,217,14,174,118,78,198,143,143,98,183,33,79,22,
91,149,132,143,255,11,29,91,137,179,43,77,141,31,237,226,155,90,10,137,54,152,224,115,117,86,186,170,1,40,55,121,229,195,117,242,20,61,25,159,175,28,165,168,116,170,202,74,157,241,171,112,15,112,203,104,
44,238,179,97,122,221,52,235,215,128,200,9,3,160,37,160,121,79,143,59,165,36,149,187,144,8,51,122,115,182,24,254,10,155,74,141,77,134,191,5,43,171,179,188,235,167,90,90,5,38,170,160,148,100,74,68,159,
117,226,50,209,21,104,8,108,180,30,130,48,80,23,121,123,222,17,79,51,230,254,104,45,199,215,179,45,73,44,166,187,224,250,166,122,0,97,225,67,182,0,29,82,15,245,107,39,51,30,81,213,161,98,215,26,91,147,
91,213,143,88,66,89,179,109,76,163,84,249,125,83,46,56,226,237,155,106,110,80,102,122,250,208,155,4,212,241,108,237,222,192,253,0,225,247,143,133,191,77,166,202,128,112,114,14,86,104,81,17,54,7,137,164,
0,149,207,88,140,250,52,47,66,42,83,56,27,60,37,193,66,92,97,53,189,251,192,116,23,100,134,127,20,32,51,155,155,66,128,187,245,71,0,89,228,121,115,21,110,166,255,169,53,170,137,84,38,159,196,228,111,221,
226,151,5,182,54,143,189,141,31,155,60,67,246,104,201,139,68,172,36,175,76,150,210,91,126,219,21,80,63,120,220,16,73,88,24,192,161,120,130,152,90,82,203,103,86,170,141,69,25,195,204,178,220,18,82,164,
130,233,36,233,145,239,14,191,212,221,106,94,93,239,4,255,16,119,7,159,140,137,251,40,235,233,211,208,153,168,6,3,38,104,61,218,34,155,180,210,220,174,127,35,214,220,134,204,37,99,18,171,153,124,168,24,
5,40,215,210,13,79,191,212,28,109,37,232,98,213,190,229,67,135,202,126,10,175,23,228,224,101,237,150,227,84,49,195,137,78,195,14,174,159,14,10,33,194,26,141,9,228,116,14,154,84,211,36,245,238,124,37,188,
9,97,21,97,168,244,142,178,7,98,18,242,30,81,213,53,195,240,34,75,229,6,105,230,156,254,6,252,176,245,22,77,142,173,126,174,163,88,240,151,114,29,163,182,58,173,18,116,168,46,75,222,25,226,69,242,112,
167,224,37,184,88,185,16,150,24,143,21,215,50,119,168,31,192,46,163,155,74,11,215,239,140,33,225,222,103,153,12,4,216,36,181,24,222,223,227,170,252,142,47,191,83,80,75,120,83,73,193,170,36,217,169,187,
92,129,146,77,48,221,5,132,67,231,5,213,13,62,116,239,103,240,175,157,204,71,221,186,214,40,62,38,221,26,51,138,229,231,174,132,147,193,40,203,113,5,41,101,185,95,130,149,172,220,122,246,91,178,197,5,
241,178,217,122,223,240,253,56,149,176,31,112,248,177,152,4,235,54,202,168,244,95,25,67,104,148,234,163,96,196,39,169,69,22,116,107,186,155,146,104,199,224,131,180,232,61,182,108,133,167,196,124,144,144,
69,125,195,185,233,46,128,136,201,202,18,137,161,156,128,226,127,118,50,39,66,154,3,183,242,208,46,218,92,255,190,52,36,80,159,12,6,169,212,43,76,217,139,126,1,226,189,184,222,151,59,97,173,43,215,210,
123,93,132,95,207,78,148,190,139,199,186,167,180,181,164,55,132,55,166,180,43,69,22,116,160,100,49,123,202,156,110,247,183,174,167,86,162,142,179,138,247,236,159,107,196,80,158,127,215,254,212,16,148,
128,232,147,175,134,95,247,71,24,68,7,112,84,107,70,28,108,241,51,140,175,29,246,211,122,119,231,17,13,31,196,154,228,151,242,124,199,234,189,155,77,206,9,98,211,85,121,198,83,188,215,123,217,179,149,
235,122,217,139,62,130,102,221,189,37,162,222,251,185,127,44,30,43,56,189,16,148,251,100,12,129,191,107,73,38,242,232,150,125,50,17,88,120,94,144,92,61,194,150,148,102,66,2,223,242,202,191,90,205,167,
137,168,85,133,87,36,75,207,0,0,32,0,73,68,65,84,102,73,85,165,108,242,147,26,232,77,24,181,14,252,68,250,157,201,2,148,245,97,42,128,97,49,192,16,231,147,242,30,80,113,143,55,190,29,200,53,53,166,4,148,
20,92,92,111,221,43,253,122,247,197,69,111,226,217,15,126,71,134,17,55,63,112,65,61,236,126,67,88,97,159,243,33,130,204,95,181,164,238,122,110,188,170,198,172,2,188,188,29,3,31,0,17,72,106,44,79,218,155,
36,172,214,2,25,154,142,174,15,26,206,184,81,81,49,61,49,205,73,103,179,99,59,142,118,100,31,174,135,62,206,177,199,51,159,205,31,230,236,40,101,66,17,14,79,129,59,218,114,158,19,133,146,9,47,121,189,
181,85,201,58,249,183,5,183,69,72,20,60,189,209,201,152,198,127,135,74,194,203,186,174,68,168,177,183,124,120,68,215,223,28,18,159,195,121,226,235,24,26,236,52,18,72,114,11,121,93,105,237,187,54,130,196,
194,62,123,38,207,188,142,30,97,101,244,14,204,158,215,84,161,249,171,214,216,138,245,21,75,15,94,241,65,90,0,82,161,163,99,153,120,152,223,93,173,125,245,194,173,228,36,189,201,219,22,59,121,141,123,
147,228,94,205,125,106,45,94,216,126,213,79,217,11,214,148,169,64,52,20,225,250,159,90,210,17,88,57,54,123,102,189,69,217,17,64,224,132,62,164,18,82,74,236,105,81,0,173,105,162,60,178,254,146,214,17,129,
37,101,76,192,61,85,232,206,212,254,174,53,50,69,198,60,70,56,166,55,68,243,4,8,34,61,213,235,18,78,148,87,209,37,214,251,101,178,235,91,192,230,93,21,215,171,110,232,118,117,122,171,135,118,93,92,14,
97,252,16,55,20,196,52,145,82,230,148,69,225,39,93,5,97,12,116,161,104,159,24,78,247,210,81,88,132,25,129,119,111,172,38,102,105,234,80,188,73,189,109,132,87,174,78,172,40,235,111,223,213,58,83,3,149,
205,83,187,10,205,191,170,208,115,182,213,168,85,182,156,0,225,78,194,81,38,225,10,117,173,112,70,218,103,177,57,193,189,131,132,11,229,6,109,118,170,145,59,44,122,179,178,4,75,169,180,151,199,224,177,
159,164,44,172,73,14,94,78,198,105,61,141,57,1,85,140,86,77,250,170,45,177,173,207,206,88,11,84,121,234,151,36,144,153,194,224,82,114,75,108,145,218,233,73,89,159,83,244,189,210,243,104,68,69,224,21,255,
207,42,52,244,78,230,228,67,13,250,50,224,175,100,125,147,235,131,163,14,17,183,63,157,193,88,110,235,109,132,95,74,54,34,47,174,45,193,179,219,223,173,117,155,163,231,178,235,113,174,250,209,111,64,98,
66,30,72,202,81,53,150,168,117,203,38,115,87,237,100,42,218,120,9,135,48,145,38,185,34,186,198,57,235,30,118,99,202,34,151,18,12,181,246,252,34,175,192,175,42,116,34,10,227,255,170,66,243,187,214,8,228,
183,55,4,159,155,206,7,74,160,114,216,68,239,251,89,84,220,157,193,216,196,53,69,148,43,27,185,120,195,148,25,220,43,54,122,243,218,21,101,220,246,112,133,195,15,209,80,208,208,206,116,208,64,88,184,37,
6,223,90,146,81,222,85,181,44,212,196,236,0,94,152,19,73,161,94,226,14,120,133,87,80,233,36,151,13,207,79,89,248,95,229,154,54,171,174,66,203,146,172,112,179,26,9,0,223,42,52,39,45,145,32,125,37,238,69,
196,39,113,139,220,252,132,35,173,84,8,54,169,230,146,181,98,101,175,128,94,214,230,90,8,149,137,5,27,57,91,175,32,235,37,238,76,202,248,79,43,138,149,69,42,169,46,169,118,154,153,64,254,81,255,176,8,
44,188,172,147,241,22,157,154,45,28,117,10,162,50,61,230,188,140,150,22,167,195,245,245,162,112,47,243,208,24,209,175,171,113,58,38,134,43,16,248,73,211,14,226,124,238,251,69,27,128,105,221,107,63,124,
130,90,83,89,101,31,163,11,62,231,154,167,119,188,224,11,123,188,76,202,197,149,237,20,129,235,221,188,235,98,109,8,123,6,226,175,123,245,97,1,246,99,16,139,26,25,81,120,72,95,183,248,137,70,160,188,157,
77,25,68,182,241,53,5,35,163,35,101,239,155,202,141,20,36,116,169,187,184,42,49,170,142,185,243,247,53,49,28,159,24,14,254,222,201,220,114,211,208,42,205,205,2,199,32,170,68,246,105,34,157,180,232,104,
4,250,172,89,239,210,106,211,121,168,13,87,80,105,235,190,82,201,214,102,118,100,93,23,108,244,242,220,208,39,100,197,77,57,68,253,0,108,179,166,151,135,67,128,50,107,182,60,52,110,66,150,103,185,146,
112,36,163,26,80,202,193,213,180,163,160,210,100,157,109,70,153,65,151,233,12,207,194,140,82,164,247,254,251,239,165,225,2,202,182,47,111,154,119,170,208,0,124,44,55,219,198,207,142,215,32,163,101,24,
142,167,207,196,12,112,37,86,68,148,58,124,117,19,107,41,137,120,103,139,5,202,38,203,41,184,222,7,242,197,223,203,247,99,221,61,179,132,129,39,252,196,156,238,226,201,52,64,187,53,89,31,5,240,160,249,
98,111,230,49,71,225,39,186,63,20,44,149,40,3,44,59,187,141,211,33,111,152,187,85,150,21,36,85,153,173,144,252,125,77,187,140,16,78,21,238,202,191,96,77,58,59,153,197,193,209,112,220,63,219,187,156,166,
253,156,132,106,97,226,105,98,221,4,54,194,124,3,75,108,65,112,21,128,54,235,37,193,174,141,173,155,186,121,214,46,135,181,216,89,188,148,51,27,202,137,136,206,229,117,62,222,56,59,65,32,220,251,101,144,
149,196,16,71,148,144,12,5,35,29,220,83,120,117,149,13,142,242,68,97,162,32,193,104,112,250,0,113,95,191,99,56,38,134,179,217,56,52,166,156,249,127,237,100,166,181,176,29,30,178,153,132,139,48,77,200,
215,47,78,200,132,39,252,78,174,148,50,202,153,110,227,165,125,195,155,101,43,217,207,34,236,234,89,236,13,188,220,97,143,243,31,77,103,79,134,43,92,147,19,156,84,27,30,65,119,79,244,244,228,30,14,211,
234,163,246,9,68,23,142,3,229,100,3,189,62,187,234,91,192,199,160,236,11,68,223,75,199,215,37,162,44,92,132,230,60,109,126,213,26,3,190,212,32,199,87,246,118,37,69,182,207,75,44,108,14,37,239,251,133,
154,21,43,97,119,2,76,36,238,149,115,46,238,149,148,61,200,42,87,112,165,69,189,215,109,243,253,220,101,196,181,237,63,147,23,205,254,125,1,22,242,114,194,195,73,39,38,191,55,37,62,26,57,172,210,75,9,
169,84,18,30,113,122,244,194,163,44,144,119,212,66,120,36,169,44,72,39,58,231,242,87,49,255,204,7,0,143,127,87,161,161,190,146,238,175,41,201,206,26,5,120,119,82,155,52,106,216,90,223,165,122,192,202,
215,213,109,249,0,235,74,130,117,175,13,207,182,162,136,23,88,215,27,219,175,194,99,109,86,153,182,205,83,123,108,94,22,252,248,216,75,123,195,154,126,156,80,107,85,79,170,251,145,36,72,97,132,41,204,
112,56,49,74,195,35,94,30,100,209,237,60,145,116,104,251,173,172,66,207,232,111,89,73,29,195,181,109,101,125,99,184,214,193,202,111,58,116,20,156,51,180,138,102,199,39,84,151,50,188,172,95,97,70,37,23,
153,123,178,141,59,129,69,221,14,151,202,224,245,141,242,226,162,61,214,218,98,19,47,69,62,6,61,201,0,20,255,121,182,199,175,83,41,156,166,188,61,20,15,70,153,161,81,53,203,146,74,15,215,57,97,221,61,
228,14,189,237,27,239,26,161,133,50,167,53,33,188,189,118,43,78,252,37,43,37,70,33,166,113,42,73,149,17,120,83,222,54,245,206,134,1,109,76,121,26,64,103,30,199,153,207,235,18,225,213,200,217,85,131,34,
231,220,199,189,246,22,129,179,174,44,184,110,189,57,177,147,128,171,75,102,125,94,118,37,211,122,6,149,254,179,61,90,173,218,133,0,208,164,225,8,201,63,49,69,138,118,131,94,68,126,244,174,60,11,200,2,
131,232,48,178,60,81,97,153,94,84,111,38,110,194,240,23,107,208,177,56,14,213,106,127,227,222,123,124,15,17,63,181,198,70,79,183,118,132,223,79,186,175,64,180,83,8,128,202,227,148,20,6,202,77,179,243,
174,243,61,251,133,55,51,216,188,35,171,247,85,78,109,167,124,220,208,167,177,204,249,33,232,124,81,35,250,145,81,158,244,11,30,241,157,158,144,11,78,4,233,157,89,234,166,74,37,132,163,50,170,207,210,
73,188,92,133,155,46,16,249,144,199,57,0,44,247,17,96,219,121,68,254,93,133,246,44,42,123,47,193,39,64,111,15,2,129,187,75,136,140,56,59,94,91,120,237,8,251,246,23,204,31,122,83,237,190,104,16,202,156,
220,140,214,249,93,1,34,247,117,124,89,18,93,10,237,31,21,150,17,63,99,33,129,71,138,164,97,199,169,19,142,253,237,187,68,24,12,166,121,180,189,166,104,135,111,253,11,103,28,117,131,144,133,197,52,247,
58,200,175,211,190,211,215,142,128,104,91,178,238,211,75,163,75,166,223,176,175,135,241,173,53,246,15,184,247,241,43,164,159,227,76,139,28,245,215,192,169,247,1,175,113,101,39,174,148,40,245,118,14,125,
147,240,118,39,67,7,28,93,196,31,139,209,199,212,50,81,224,254,19,221,54,238,61,241,111,204,150,197,96,22,254,85,173,180,4,183,236,158,211,232,99,223,147,148,17,46,69,151,76,194,58,59,80,240,40,172,235,
94,227,158,242,183,244,229,150,171,95,18,45,96,69,205,210,43,104,119,209,68,124,238,97,110,246,217,158,207,167,49,130,30,63,124,75,24,202,202,111,87,20,176,222,230,15,91,180,46,169,213,11,231,37,89,175,
222,20,230,18,169,68,164,117,247,66,127,253,71,238,214,92,8,119,167,177,47,67,36,225,129,252,163,8,9,70,248,28,229,82,179,200,227,246,35,38,252,85,131,211,112,92,46,131,62,197,13,43,51,253,171,94,85,197,
158,199,79,164,165,44,243,94,103,130,145,178,224,212,26,219,6,59,129,172,126,88,147,105,111,127,202,33,172,141,131,126,188,4,74,177,175,238,82,234,91,154,213,231,98,19,220,137,246,149,91,57,201,8,0,121,
77,214,42,161,232,29,22,70,128,166,211,67,227,13,195,195,233,179,228,2,56,226,109,53,235,168,37,62,154,42,0,75,167,195,178,104,44,10,7,133,7,229,24,89,69,216,47,30,225,150,182,28,228,18,149,9,77,202,250,
68,1,13,87,109,41,230,255,81,107,204,249,23,50,123,91,214,140,37,19,247,32,233,45,87,115,99,66,178,251,224,56,65,38,111,31,66,134,179,30,200,174,255,241,248,26,12,203,160,202,39,60,230,249,137,163,34,
24,52,170,157,169,116,62,20,28,4,134,19,174,32,36,165,132,19,254,177,219,20,150,232,212,33,252,131,117,101,234,234,72,176,44,63,231,51,0,16,1,251,65,89,115,112,83,122,55,227,197,183,117,68,189,153,176,
132,167,165,38,163,220,36,89,208,187,93,83,202,42,172,143,82,238,34,84,224,141,208,154,241,205,181,251,169,36,176,245,98,11,30,216,66,185,82,172,117,211,187,107,36,60,211,38,90,129,253,67,22,209,221,10,
132,119,196,1,71,128,193,1,46,72,186,150,237,125,168,9,141,41,156,119,215,252,98,48,239,13,163,73,39,90,40,148,208,39,149,52,10,127,4,230,56,108,76,25,189,171,82,21,141,61,68,184,37,133,145,200,232,157,
242,127,213,26,71,185,42,203,205,177,54,20,224,75,88,3,116,244,254,131,59,75,175,150,232,99,41,200,203,98,47,174,246,214,218,50,246,193,133,158,35,193,52,24,165,126,36,250,244,134,54,156,20,221,184,16,
196,248,195,0,178,133,217,5,159,38,12,114,226,32,208,76,192,141,250,117,156,162,80,140,196,172,207,45,209,81,184,132,94,133,88,172,6,187,20,234,253,86,61,191,192,61,85,201,36,45,254,183,214,216,230,164,
254,101,76,76,173,81,231,136,22,240,182,170,252,24,97,95,155,13,185,245,102,250,56,140,247,44,95,162,133,183,125,24,189,156,98,10,151,249,211,74,210,49,171,2,79,255,144,199,47,47,133,12,188,19,178,12,
164,117,150,197,102,226,34,81,244,27,42,76,146,119,95,104,87,23,163,110,47,252,13,218,204,125,202,181,232,230,50,155,70,165,145,253,136,62,98,146,240,97,162,8,203,127,215,26,143,234,82,48,167,189,146,
95,194,26,2,165,26,219,103,148,186,14,50,229,221,4,98,173,189,174,23,235,147,42,42,175,227,209,194,33,40,25,24,152,224,207,127,149,208,13,230,196,121,255,25,203,249,158,178,245,192,199,44,149,234,157,
228,223,91,213,25,5,232,38,243,217,143,110,129,82,217,253,16,52,229,75,240,238,106,255,54,89,20,201,199,93,255,26,132,19,8,58,126,226,115,92,211,188,21,24,48,234,134,141,230,215,14,13,51,19,175,55,95,
202,161,77,73,199,60,120,176,238,249,69,139,95,172,233,251,207,60,157,57,226,170,17,168,133,53,18,104,83,59,75,38,251,59,59,48,210,106,37,68,57,91,97,102,8,154,127,26,215,78,169,22,200,243,197,22,190,
18,88,247,217,79,175,225,118,194,106,246,27,124,101,213,144,80,67,122,235,203,23,191,3,26,129,205,198,122,47,171,1,228,224,12,137,84,142,172,126,63,187,199,181,174,247,178,231,58,157,36,107,183,88,63,
154,1,206,108,224,87,254,240,251,138,192,221,189,3,224,12,99,50,218,104,208,184,239,193,219,86,236,132,46,45,111,112,20,216,252,189,21,70,154,20,120,47,149,207,233,9,220,193,236,176,124,37,18,233,19,195,
173,95,122,149,41,117,110,149,255,171,214,200,52,180,66,22,129,203,251,215,79,54,97,5,58,22,74,32,87,194,130,254,175,214,140,23,224,178,231,154,152,189,3,71,101,35,217,200,42,194,123,37,82,63,211,13,22,
0,225,237,167,249,85,166,232,175,164,102,24,253,83,184,28,255,82,176,115,103,199,140,106,98,21,124,14,61,11,112,101,148,233,205,4,66,233,44,95,190,63,97,42,8,243,56,69,115,65,207,244,155,157,63,48,121,
46,15,178,42,25,146,94,65,125,247,72,53,97,205,143,58,109,56,197,26,145,224,70,132,163,139,151,43,195,89,204,54,211,245,241,5,142,79,18,180,90,236,63,73,147,26,63,99,136,160,233,190,83,198,137,237,83,
45,43,77,31,104,54,56,248,24,194,193,142,50,170,13,161,112,107,19,76,16,94,233,162,184,112,96,177,224,142,251,81,246,208,186,199,50,66,217,15,82,30,148,153,43,249,159,90,99,27,90,239,120,53,56,137,112,
63,95,160,205,246,152,174,180,24,1,174,61,45,191,226,181,57,126,105,47,245,82,239,239,11,22,1,229,83,15,153,28,252,135,3,54,8,124,146,126,4,159,80,174,21,226,211,255,3,113,52,77,253,111,246,230,191,57,
82,40,233,253,11,0,120,70,77,123,85,63,175,79,82,111,230,5,136,122,191,171,213,183,13,198,124,254,81,41,242,183,172,26,22,122,211,115,194,108,191,35,3,78,196,227,201,248,30,68,255,170,17,173,181,232,26,
61,144,239,77,245,126,95,246,183,76,185,104,37,217,15,238,22,228,130,68,252,180,78,68,132,155,251,73,93,165,212,111,157,8,175,63,227,67,183,254,162,96,35,41,178,51,21,74,166,165,184,58,225,224,52,38,65,
66,103,35,126,45,95,83,183,207,57,247,237,231,63,211,77,4,250,24,198,185,116,224,87,34,26,131,177,246,233,238,211,182,13,89,18,95,14,223,79,221,215,70,24,108,28,118,68,222,0,177,192,251,152,101,214,13,
196,227,206,77,85,208,218,150,169,63,255,240,29,201,32,89,143,38,129,95,71,45,206,213,222,251,151,163,101,102,214,139,200,175,95,202,229,132,19,253,140,243,187,8,218,7,118,247,101,123,156,33,7,185,216,
253,139,176,126,63,245,12,68,31,12,205,223,163,40,27,207,155,178,106,111,105,77,93,248,72,168,7,166,126,214,240,0,37,172,13,30,235,14,22,119,120,224,207,62,211,154,211,55,61,250,197,57,95,105,234,240,
29,161,3,189,197,15,154,42,253,165,249,241,235,79,243,131,242,35,173,51,174,243,29,63,157,1,208,212,140,195,23,142,176,154,228,76,191,233,175,81,245,113,242,249,111,89,53,71,155,71,12,73,115,66,24,113,
14,214,108,36,249,23,209,80,246,73,212,191,103,179,174,119,78,185,253,252,42,112,102,9,129,195,68,226,251,16,244,67,254,82,45,69,4,62,180,92,193,175,38,21,128,207,111,215,229,163,130,64,27,203,113,90,
250,142,40,138,40,152,211,89,4,57,142,170,145,56,224,102,60,241,191,99,184,141,148,243,29,181,61,118,95,150,26,134,69,36,81,57,41,146,8,234,88,30,74,186,49,152,4,157,164,80,206,118,165,147,215,97,191,
155,240,21,190,54,55,219,9,177,78,99,16,49,188,246,123,156,176,147,63,56,254,201,134,64,19,2,247,65,29,254,186,50,191,7,10,192,199,77,194,44,190,127,193,1,64,57,116,221,75,73,146,174,179,48,107,30,227,
69,227,88,66,230,250,229,183,231,74,68,254,255,117,157,59,150,235,186,146,109,231,209,40,248,104,164,28,249,203,137,22,196,53,194,151,195,70,194,71,25,207,88,1,82,121,110,61,142,220,185,83,18,5,2,129,
248,255,80,3,106,40,160,170,72,185,90,55,85,178,243,36,250,28,139,76,111,218,24,27,141,113,192,116,244,179,183,10,116,81,33,52,79,215,208,239,103,218,220,243,233,30,103,61,2,101,103,76,8,96,43,94,100,
28,155,81,148,181,165,132,176,179,132,255,186,146,131,13,137,245,188,131,75,69,54,234,11,192,9,141,193,78,190,32,51,126,48,121,221,12,254,194,50,87,37,241,174,251,240,11,113,219,112,195,42,138,149,100,
196,241,226,71,169,72,165,138,74,212,176,137,129,114,23,157,31,95,133,24,27,68,81,18,44,71,131,93,95,150,193,74,159,224,75,177,166,74,117,239,228,232,169,56,44,80,197,235,172,59,243,39,188,247,47,117,
243,185,74,127,36,188,197,132,137,5,19,97,209,176,75,168,62,160,238,13,135,86,77,244,247,208,251,237,158,239,213,174,57,147,158,97,94,214,41,163,163,135,217,53,61,254,66,232,228,0,4,110,138,180,169,161,
34,55,205,56,111,52,214,118,234,7,130,233,174,241,126,78,76,114,6,145,1,235,2,222,165,146,86,226,173,103,15,6,39,97,92,251,37,137,160,132,242,6,233,255,247,18,227,137,119,114,83,34,126,252,193,171,31,
14,159,213,217,28,190,81,252,235,26,236,157,12,212,190,73,149,142,223,183,47,39,159,37,48,182,171,4,247,46,101,14,133,159,185,1,87,86,89,235,27,128,28,205,110,177,80,133,222,42,184,170,86,21,76,184,198,
32,114,97,175,118,90,164,120,135,224,103,141,225,160,130,195,39,47,140,71,195,170,199,89,63,39,26,252,247,42,191,223,157,8,227,72,199,106,108,80,209,176,106,168,28,124,22,227,7,136,103,38,18,219,221,189,
196,251,118,59,45,227,24,130,41,184,203,130,34,189,152,126,86,151,236,198,145,86,42,87,140,185,138,37,28,214,60,44,129,114,36,76,200,254,44,173,76,146,57,193,234,233,143,230,87,116,52,29,200,77,224,204,
20,170,172,58,140,62,43,140,91,35,232,43,254,47,144,221,92,139,95,167,201,143,121,242,35,110,79,213,71,235,180,229,111,251,187,189,74,160,230,187,184,143,0,237,209,40,84,119,171,192,163,242,221,99,11,
220,83,161,243,157,76,228,63,115,160,223,234,71,88,103,165,224,68,210,19,34,231,199,7,197,242,123,89,113,240,191,216,21,125,154,248,63,255,241,136,177,25,142,250,254,124,237,143,126,208,151,138,72,130,
239,234,131,61,250,214,254,211,136,15,68,123,138,34,9,78,164,170,239,181,178,80,184,255,32,215,105,246,213,35,248,189,191,35,223,122,37,63,183,58,81,0,104,192,240,236,215,217,31,170,5,92,53,202,31,114,
197,58,179,15,207,254,3,171,51,239,48,44,98,151,168,216,131,124,121,0,23,223,103,38,174,193,213,141,61,255,98,51,42,216,144,44,221,65,44,128,173,86,65,232,154,129,253,32,118,102,229,248,97,67,128,84,72,
93,158,242,238,34,61,209,208,160,186,27,139,116,196,239,237,158,249,133,85,27,99,118,77,84,11,208,115,21,29,123,121,48,177,221,225,158,182,233,208,90,251,89,136,0,62,68,4,25,223,190,207,9,134,181,51,94,
165,42,148,25,149,17,129,93,201,97,96,31,195,242,25,232,150,49,137,37,122,67,213,188,66,7,82,112,212,215,163,16,223,161,56,192,46,236,170,194,125,221,255,15,27,14,204,243,13,161,164,151,172,63,176,194,
108,169,196,253,253,134,119,19,30,84,97,237,207,155,117,93,229,211,103,129,128,249,93,96,51,247,17,85,29,210,34,87,220,49,166,2,74,249,58,19,76,112,111,24,50,157,32,69,0,58,229,98,42,69,112,29,29,59,34,
243,132,230,58,87,134,159,244,24,115,140,128,196,14,241,187,123,49,254,66,149,97,123,110,70,213,45,63,207,74,107,241,167,210,115,139,199,160,56,8,212,214,149,81,11,3,231,140,217,38,58,9,7,66,203,103,136,
99,247,95,172,53,141,96,144,49,91,195,143,243,131,69,159,57,38,80,188,236,92,139,190,175,181,124,161,12,187,42,108,157,163,161,2,181,198,132,18,159,190,97,201,104,200,99,211,196,213,40,168,189,59,9,73,
238,200,211,205,87,97,95,139,41,145,139,78,218,96,149,106,138,147,141,11,213,243,167,161,184,13,97,110,244,107,96,123,195,141,143,158,66,35,184,133,54,197,2,55,95,191,68,128,88,145,100,176,130,217,183,
173,88,189,175,6,17,157,181,112,246,5,226,37,13,68,202,65,211,232,197,125,135,80,126,82,142,234,16,236,34,247,48,157,9,135,24,80,69,186,142,233,38,153,123,53,133,116,188,138,62,241,42,189,176,27,253,230,
46,71,153,235,217,237,85,243,230,59,250,17,232,213,252,250,137,1,159,203,119,235,168,47,7,106,0,137,160,171,217,101,21,235,109,230,82,36,65,66,198,199,98,172,53,142,236,15,90,45,111,68,232,57,255,243,
159,126,84,239,181,161,229,21,133,247,18,176,114,113,235,9,177,25,36,39,188,115,139,160,216,53,223,230,42,237,39,241,12,236,254,136,196,82,59,90,132,3,221,8,169,213,217,7,227,245,135,55,1,134,85,167,191,
114,63,85,141,107,205,217,143,149,208,183,88,208,153,132,116,45,213,124,83,145,177,249,51,182,149,155,107,205,79,251,7,34,253,115,4,229,97,188,47,36,212,230,235,160,139,252,234,79,80,21,24,123,60,129,
47,210,14,126,116,14,159,59,239,91,87,178,83,124,207,251,93,241,57,170,204,161,155,2,218,120,56,153,196,46,83,16,101,13,224,250,3,43,203,74,254,5,171,6,109,111,246,193,129,6,115,179,157,243,201,81,118,
179,243,31,226,230,78,238,225,251,102,53,113,153,254,34,105,31,124,152,43,199,126,153,238,27,115,123,252,141,245,131,216,78,5,70,123,160,59,4,18,124,135,207,32,143,166,44,0,166,76,124,136,61,170,106,97,
179,33,24,217,82,86,16,136,110,73,9,92,251,244,70,67,142,55,223,179,89,15,195,2,24,133,15,250,253,23,12,253,95,91,165,7,183,250,81,182,30,221,123,135,41,244,110,154,5,110,124,249,134,105,189,136,204,12,
50,54,233,147,18,108,197,4,116,177,192,11,116,27,40,153,68,29,125,65,34,239,34,49,216,101,95,242,16,59,214,38,22,93,201,7,16,146,222,21,177,160,84,85,119,195,101,248,245,108,23,164,211,191,5,101,128,50,
19,13,31,233,87,72,232,106,136,29,134,229,236,2,6,79,46,208,161,59,21,28,171,185,63,184,53,211,108,212,113,129,125,57,33,190,8,230,184,34,102,126,13,175,117,47,34,251,255,194,39,140,1,102,108,71,131,120,
245,35,207,195,242,236,71,83,102,134,18,81,118,119,102,168,11,228,78,168,62,249,114,5,9,85,78,226,149,113,30,136,72,20,119,85,201,250,27,62,188,215,253,142,170,212,138,147,174,219,236,190,63,23,148,149,
233,206,38,56,51,125,48,172,254,88,90,88,229,42,34,119,117,80,151,230,22,66,100,172,252,36,107,218,18,54,238,231,25,215,242,172,90,44,144,64,230,110,67,249,213,143,189,31,166,60,65,11,124,138,66,65,149,
51,240,2,174,9,184,161,138,121,33,171,86,134,64,179,163,107,220,215,183,19,66,47,82,66,202,132,233,88,95,85,123,26,46,216,160,138,156,9,147,242,33,159,63,176,2,190,18,93,30,244,251,246,15,21,182,134,37,
202,236,189,154,118,250,218,71,100,84,99,122,178,34,180,143,146,37,131,152,140,100,18,236,211,2,225,167,109,78,99,214,47,180,128,219,148,95,64,50,33,194,13,29,112,121,70,61,30,212,212,36,216,92,85,31,
7,80,111,86,51,249,244,154,220,230,170,10,161,245,60,106,9,174,247,24,3,174,32,14,173,180,46,55,129,3,251,85,199,121,242,200,61,127,124,232,206,68,105,85,175,250,19,123,154,13,7,209,63,24,34,45,246,57,
124,90,80,138,136,36,151,160,42,172,84,71,2,157,70,247,175,240,125,231,247,255,9,233,200,32,187,41,26,224,167,79,209,128,173,81,139,200,21,194,160,17,192,103,239,195,156,188,42,29,147,182,7,129,138,53,
200,141,222,153,123,169,130,186,75,37,14,219,189,177,233,126,248,191,16,235,151,139,220,219,126,126,53,228,220,146,191,48,27,203,232,176,33,160,205,225,133,195,88,167,74,130,140,78,253,56,246,6,56,110,
232,13,2,236,200,249,157,95,80,76,190,237,123,127,20,234,221,97,108,237,197,184,190,0,82,186,173,91,163,67,22,36,165,160,35,121,206,190,234,113,4,12,118,236,45,2,102,140,192,199,112,182,91,147,233,165,
62,204,141,131,35,15,98,157,69,214,121,249,27,180,190,95,85,225,252,35,234,102,229,31,146,163,191,106,210,18,46,18,42,12,180,216,25,135,159,217,207,253,186,119,222,94,219,128,147,178,7,16,59,130,197,167,
128,200,166,75,160,46,117,122,124,137,252,124,152,236,81,34,227,95,161,101,169,210,9,148,191,18,203,241,65,101,192,24,131,61,106,229,102,92,119,98,176,152,244,77,215,239,112,110,76,212,163,248,247,29,
51,255,171,197,2,210,24,196,237,48,172,170,78,87,36,194,178,178,121,221,45,119,45,98,18,130,176,146,105,143,107,121,19,95,135,5,116,159,84,32,153,183,194,144,158,202,6,166,225,116,92,207,37,54,57,75,5,
233,19,228,163,138,252,156,155,97,86,207,197,6,134,35,55,17,4,62,237,171,90,155,169,1,49,71,126,249,186,195,245,226,98,209,140,254,89,8,192,122,88,207,115,5,180,198,127,3,76,32,198,78,50,30,239,144,233,
170,83,90,226,193,172,97,140,201,38,172,32,142,236,109,143,182,175,122,89,208,66,4,37,72,228,99,234,78,254,248,238,135,24,250,119,150,203,82,69,133,150,6,238,52,255,29,119,217,90,133,78,249,2,94,217,190,
87,29,166,236,29,32,141,11,237,156,145,201,126,19,239,207,234,232,14,171,255,61,68,229,115,5,90,218,89,245,109,166,115,144,189,224,95,150,99,22,193,126,138,27,19,136,60,46,152,251,237,200,58,128,148,172,
180,67,167,9,253,241,82,153,103,149,148,173,50,200,224,140,120,244,81,246,253,231,243,213,130,176,242,181,242,29,25,31,243,8,168,210,190,130,163,132,170,38,42,185,138,204,56,113,180,249,202,207,168,230,
170,215,224,59,190,180,16,60,191,254,48,160,206,96,61,92,169,61,14,191,120,118,100,3,168,239,37,41,74,103,226,193,41,127,129,147,108,239,230,139,77,203,163,64,65,6,213,106,221,47,180,94,156,199,54,218,
149,227,41,100,52,189,2,149,189,123,145,216,206,1,216,121,165,46,233,184,20,218,187,19,192,123,183,27,76,12,150,176,98,26,192,119,103,31,187,61,8,50,69,124,98,139,245,229,195,123,18,111,224,196,63,127,
96,213,16,169,67,104,213,239,62,189,92,112,225,88,191,180,218,85,216,244,237,60,91,18,56,216,242,147,131,22,7,36,74,237,13,118,58,52,251,202,190,5,120,5,224,25,4,176,61,151,103,64,59,98,227,60,9,130,117,
160,21,75,44,216,153,135,25,20,140,45,198,128,143,125,95,65,4,117,149,96,39,81,107,168,96,67,228,72,5,164,187,185,198,135,239,119,124,56,89,34,48,227,89,205,129,252,13,43,95,245,3,55,200,241,47,94,166,
3,64,138,78,251,145,8,216,56,2,95,152,213,67,91,213,35,24,117,208,112,244,31,247,226,245,242,236,60,184,244,119,54,193,237,155,252,37,93,179,45,93,39,88,238,54,68,211,108,32,235,34,115,236,77,17,92,185,
191,121,177,226,248,135,205,105,106,199,151,20,68,97,70,190,147,207,250,50,163,46,11,66,62,160,146,96,246,19,255,75,218,241,47,224,252,177,28,5,221,19,241,135,244,131,211,94,224,156,125,99,54,102,136,
101,236,188,201,52,116,8,240,230,240,227,117,104,247,116,223,168,198,6,187,193,178,30,198,241,40,89,83,98,214,71,12,93,99,124,247,151,108,125,188,52,3,230,204,235,2,237,120,171,222,44,200,239,96,48,3,
183,1,9,32,168,34,163,33,113,177,191,250,240,134,15,31,112,25,114,77,170,105,178,144,139,2,123,50,63,188,234,6,217,113,121,251,126,70,210,117,198,247,86,167,251,36,218,84,200,198,47,195,42,3,237,161,49,
40,118,132,18,254,21,32,139,124,153,118,69,213,207,46,144,17,100,7,206,171,249,212,145,225,226,93,197,135,172,218,131,157,159,250,64,64,49,151,120,111,248,188,121,191,129,235,91,116,230,235,202,153,115,
37,89,53,201,61,120,131,171,8,34,8,244,97,44,58,189,224,11,115,38,232,84,233,250,90,252,50,49,110,94,251,188,254,1,95,60,24,81,55,61,233,244,245,40,67,214,34,246,118,139,218,95,153,177,71,102,53,199,226,
7,210,188,2,245,83,218,47,213,149,84,121,115,61,184,79,105,78,216,206,161,141,36,80,165,15,38,157,228,140,115,214,252,186,54,147,171,38,107,81,111,110,126,189,32,92,116,72,102,37,164,187,157,138,40,230,
230,218,59,221,193,135,15,49,205,186,110,69,171,113,252,76,242,120,209,30,182,2,212,31,203,241,185,18,130,200,65,85,56,133,164,218,197,152,100,244,249,101,212,102,228,150,115,98,199,1,241,93,248,24,188,
78,5,65,11,15,112,53,93,179,248,144,64,249,54,131,83,72,117,173,123,219,74,218,21,193,92,118,11,185,232,136,55,188,235,173,85,147,8,135,205,39,62,89,118,51,190,165,28,4,17,169,11,50,7,16,124,6,239,62,
164,96,65,174,92,78,10,186,215,61,239,174,14,0,85,23,19,136,140,113,220,120,212,115,255,221,222,64,189,239,105,74,209,206,177,117,90,8,113,152,217,97,167,73,193,142,216,218,205,200,232,38,0,144,188,70,
65,228,192,204,176,60,60,105,3,92,219,175,93,179,69,81,213,212,24,144,147,130,176,250,78,4,225,158,30,162,170,102,21,122,199,206,15,64,45,23,146,50,200,213,154,123,230,28,43,60,221,47,185,119,92,236,25,
193,33,188,229,117,159,226,202,149,67,55,44,10,222,93,189,188,207,114,105,218,106,126,214,5,85,46,19,137,180,91,67,213,231,168,254,114,163,180,158,84,97,59,191,134,83,48,242,0,41,12,72,244,202,72,210,
65,102,169,14,192,188,87,157,120,93,162,211,28,19,78,226,220,132,55,98,124,155,14,190,228,230,139,108,73,107,9,81,223,129,131,3,19,93,153,193,87,1,237,172,97,53,7,29,172,111,140,145,43,198,39,19,88,211,
25,27,76,32,107,58,164,55,179,14,251,50,80,236,124,124,136,16,56,196,1,84,91,89,100,123,213,51,25,21,123,28,111,207,49,87,79,79,65,158,106,178,2,142,127,52,128,206,208,178,158,197,224,108,72,116,168,98,
167,84,232,156,144,219,87,220,90,224,82,148,32,215,55,50,50,99,125,157,180,160,130,154,69,169,46,214,121,238,155,90,65,198,26,41,152,200,238,131,4,55,21,248,176,191,82,38,221,59,127,53,251,155,253,98,
1,139,231,16,22,234,164,217,218,235,4,141,250,106,174,86,24,177,76,38,135,83,239,216,13,138,7,192,130,142,16,54,112,90,165,167,121,77,70,198,200,68,240,207,63,121,208,104,108,71,113,206,107,115,192,78,
9,126,10,121,68,247,72,81,53,7,241,206,244,249,64,215,155,114,194,33,229,70,29,241,253,180,139,204,114,66,215,177,0,1,85,192,247,3,221,217,135,96,87,63,250,175,236,243,148,206,255,167,235,136,238,12,146,
191,119,247,173,42,44,139,204,135,241,233,29,50,98,241,251,13,47,129,179,26,34,127,254,117,144,244,245,184,241,178,138,172,195,215,12,10,177,177,153,153,208,240,62,18,187,37,117,240,133,64,248,44,165,
85,133,125,163,136,181,192,71,2,222,214,165,58,67,81,141,223,124,201,79,66,229,24,21,104,239,154,148,156,95,10,122,206,160,241,35,15,222,244,117,189,127,49,171,159,112,139,202,63,84,1,112,218,166,7,240,
91,128,76,16,193,48,150,181,67,32,14,148,241,90,139,87,208,156,172,20,39,105,33,12,247,186,239,243,110,3,132,6,97,243,80,53,9,72,86,144,209,125,201,196,156,189,103,45,175,214,174,111,59,58,44,221,102,
51,194,84,196,32,62,201,182,57,186,35,161,134,128,75,139,21,78,54,187,205,43,143,106,16,156,126,101,102,242,15,187,214,185,243,78,130,35,131,157,190,41,130,16,50,15,126,154,50,7,36,164,114,64,70,203,234,
86,157,194,0,43,65,188,50,15,215,47,179,144,29,252,96,177,55,246,176,186,132,11,146,207,76,9,86,125,9,240,33,165,223,30,100,189,189,42,201,90,61,245,147,155,52,233,224,13,179,116,101,38,153,65,85,108,
7,219,28,104,189,212,71,225,172,117,213,100,209,28,190,121,208,5,168,165,221,85,179,7,175,130,73,69,195,243,216,206,136,125,22,160,157,238,214,215,83,237,235,100,203,88,179,202,150,6,105,161,153,36,20,
84,192,43,2,51,218,32,187,230,86,137,33,10,162,222,213,136,21,9,108,47,252,77,13,243,254,4,62,201,247,196,25,14,47,80,93,11,138,94,38,120,197,55,150,188,15,212,200,16,89,62,9,97,192,24,239,254,70,174,
57,207,25,99,230,240,246,147,190,219,231,110,91,169,19,87,132,96,193,110,251,182,2,238,51,146,171,225,85,74,139,252,223,4,255,128,76,50,149,206,139,201,147,221,14,193,35,19,83,188,200,86,73,122,88,6,133,
236,55,141,54,130,124,253,152,220,125,34,244,165,37,179,64,171,83,102,131,120,45,230,230,243,246,227,177,88,116,152,57,212,137,51,145,82,80,146,178,22,181,179,54,57,22,214,192,180,150,181,5,3,196,6,54,
198,214,178,238,119,246,235,225,79,71,34,38,42,183,130,56,24,112,2,179,252,185,34,91,7,115,152,193,150,75,243,42,195,174,223,30,249,74,160,180,239,84,168,202,140,24,17,26,104,55,67,213,104,239,200,13,
211,4,50,87,25,203,31,187,8,170,21,142,122,51,175,136,53,103,167,185,26,167,214,7,224,91,124,152,65,36,163,72,185,9,1,28,54,48,114,238,70,201,70,191,111,192,130,186,212,232,59,201,78,90,0,136,114,90,52,
81,48,198,57,95,25,142,139,70,160,97,214,115,212,179,190,12,141,221,180,35,0,0,11,96,73,68,65,84,149,16,205,163,142,89,109,14,151,126,219,48,59,161,48,221,16,151,177,178,50,171,172,165,26,144,150,171,
116,197,161,237,223,158,206,76,78,122,175,233,155,93,148,214,218,121,148,36,243,233,9,201,100,126,32,89,59,18,182,118,32,203,102,65,13,114,43,161,166,91,132,53,21,175,222,144,183,25,210,213,156,189,102,
63,117,246,250,189,139,199,82,41,1,22,142,101,10,173,159,42,168,115,69,246,4,210,3,4,216,62,178,26,17,28,237,227,142,27,138,234,162,86,206,179,188,17,62,24,251,71,204,166,54,39,235,173,170,16,174,99,127,
224,141,138,251,176,1,232,37,47,88,196,156,139,149,88,104,74,162,234,142,218,85,65,22,20,44,214,167,41,120,178,96,182,135,182,217,213,106,50,62,136,215,108,160,47,11,179,135,46,1,16,229,100,2,224,113,
80,0,236,163,70,152,77,101,227,154,209,138,206,217,202,60,152,117,92,142,105,206,127,144,84,180,198,48,176,94,224,113,108,134,102,102,32,84,197,119,133,250,244,12,102,219,67,42,234,129,215,130,152,1,145,
107,129,230,228,253,238,174,102,2,170,20,121,212,163,163,50,102,153,126,215,156,115,174,67,144,97,38,95,203,180,200,172,150,97,76,142,45,182,221,184,180,193,255,147,83,122,243,223,199,241,5,20,145,121,
119,202,181,59,221,48,75,250,133,223,254,231,159,196,136,200,81,200,127,47,1,173,145,249,165,167,230,210,181,72,156,128,51,218,3,106,200,122,148,185,126,242,218,231,58,121,193,61,236,96,143,239,187,16,
215,34,54,84,231,163,120,144,201,58,217,234,63,147,154,171,167,208,207,252,115,5,100,167,69,89,246,63,223,19,80,61,213,159,126,1,255,186,34,255,59,29,62,35,227,89,44,47,34,34,50,168,97,159,233,15,204,
141,54,20,213,21,86,254,201,164,236,242,130,162,80,229,4,198,69,89,3,2,208,91,77,33,19,88,161,213,254,92,230,36,42,115,236,69,8,222,82,22,104,83,101,39,83,193,123,249,184,63,96,158,196,210,152,107,226,
230,30,195,222,154,31,177,194,204,76,116,180,207,189,243,225,42,129,21,9,74,122,156,17,253,145,41,207,28,252,228,64,248,113,129,223,202,246,32,0,175,204,62,215,218,231,183,83,255,141,94,176,211,158,130,
227,47,104,80,1,32,102,44,141,218,43,88,222,248,166,44,51,6,87,213,22,113,1,1,159,165,175,117,207,145,85,157,195,238,246,194,243,135,205,24,214,1,176,188,71,31,22,193,98,86,110,248,78,59,60,58,201,248,
99,108,57,225,235,2,74,153,226,36,15,233,166,194,12,168,59,132,69,243,245,3,164,179,44,123,79,187,193,176,115,21,226,159,255,160,115,214,37,127,81,91,77,126,77,132,70,102,230,135,61,60,68,36,158,226,92,
162,166,251,129,140,125,189,125,24,229,47,212,227,235,181,127,63,228,252,144,177,7,25,206,189,20,205,1,4,208,77,50,245,155,150,121,6,73,152,239,154,239,107,153,176,251,231,208,125,27,213,241,93,15,153,
105,156,156,210,234,5,69,58,37,246,135,228,110,59,219,210,47,143,244,243,159,209,221,72,224,5,67,155,33,193,120,130,180,55,49,62,84,89,48,4,239,204,114,239,246,216,210,164,10,62,170,139,5,62,156,251,205,
122,3,179,30,130,238,147,163,35,23,25,43,147,172,111,146,213,11,105,5,168,10,106,45,144,168,253,95,176,210,102,234,77,124,198,178,104,109,180,83,155,129,170,37,68,228,10,56,239,141,253,160,84,1,69,146,
213,30,195,0,78,209,22,105,202,179,0,108,172,235,186,128,74,127,250,194,109,5,170,154,39,202,115,21,112,235,239,61,237,106,15,48,238,102,183,11,87,174,147,197,242,158,185,201,175,170,208,122,76,10,231,
71,124,200,136,126,108,196,138,152,154,128,43,198,90,20,54,34,151,102,241,84,215,250,54,138,85,85,123,59,153,66,192,7,38,53,73,77,222,37,136,130,136,173,19,40,108,63,29,208,251,46,48,206,255,144,157,53,
37,247,175,12,136,72,14,180,172,34,201,208,227,127,236,199,50,141,87,220,101,216,221,5,186,14,220,188,144,60,128,59,25,92,22,165,191,66,196,183,168,209,202,54,207,7,11,67,11,149,200,201,119,197,46,88,
190,109,247,240,66,39,229,113,241,60,88,23,254,224,90,156,211,104,150,152,201,115,164,243,82,113,81,155,74,225,211,81,33,146,172,3,31,1,37,51,15,211,139,167,157,196,61,177,227,110,238,79,34,155,215,37,
201,118,37,235,221,124,21,168,131,15,135,149,247,39,225,191,140,168,126,191,23,19,126,130,68,66,218,54,104,57,74,44,130,25,153,172,200,57,157,147,177,249,172,119,36,225,131,90,139,28,80,3,89,245,245,38,
65,99,117,204,99,113,171,150,30,9,56,106,49,219,192,158,179,168,169,5,117,73,23,221,45,67,169,19,213,13,206,110,144,136,225,4,219,184,17,236,152,131,17,65,103,142,180,143,102,200,198,74,20,188,40,192,
61,80,220,8,184,142,161,13,7,205,48,136,108,186,6,98,180,218,114,62,105,134,67,26,121,79,127,216,72,200,176,165,146,177,222,144,147,24,145,115,108,42,235,248,94,242,130,45,74,173,190,243,0,101,102,187,
179,116,93,204,170,253,164,230,16,11,171,187,107,77,98,93,221,126,230,211,51,57,119,129,216,198,245,163,67,236,29,52,23,151,57,85,123,170,242,167,129,158,41,97,155,160,72,208,63,255,219,224,248,151,62,
6,127,9,208,87,236,34,186,221,4,77,49,62,175,235,174,16,140,239,39,99,83,225,174,13,205,15,140,207,115,49,249,252,36,97,250,44,175,6,45,117,38,33,234,80,240,97,243,243,93,186,62,157,22,59,223,190,97,46,
206,125,32,238,110,17,159,60,124,160,206,200,162,142,116,247,240,116,208,94,21,62,153,44,127,180,210,86,184,250,165,229,36,240,58,32,217,106,180,108,130,107,158,209,52,209,87,55,138,108,219,223,184,94,
233,105,244,156,115,125,93,86,28,124,76,180,115,70,18,84,240,14,45,31,194,197,84,136,217,236,74,141,60,218,142,87,20,200,194,238,176,36,86,81,107,151,74,10,214,168,73,172,88,16,156,100,178,26,91,118,182,
190,243,199,93,101,116,82,241,0,158,130,227,182,162,238,122,145,125,188,239,38,143,36,143,30,118,144,230,117,122,106,223,248,149,60,224,57,238,118,73,72,97,247,67,249,148,221,251,75,82,181,65,237,107,
117,82,171,159,156,241,249,100,76,136,164,242,40,141,177,70,118,8,178,128,165,54,101,247,230,54,17,19,250,240,240,155,45,168,168,74,148,115,205,140,61,189,25,155,200,130,172,210,201,163,22,180,44,175,
146,123,19,232,160,212,129,89,62,183,146,100,120,135,195,86,56,118,107,37,225,76,156,4,120,21,105,175,75,193,239,33,75,15,90,89,109,212,157,187,25,247,14,1,58,207,86,148,227,215,72,85,23,17,196,215,192,
79,88,68,6,51,222,62,144,97,102,139,20,65,211,70,118,212,172,170,247,168,238,16,229,121,48,5,204,25,179,88,188,201,122,51,39,177,78,195,136,35,115,138,44,250,88,169,30,161,74,54,167,26,56,145,52,223,166,
12,149,163,56,112,82,98,2,58,30,107,60,8,120,69,62,204,194,210,40,186,245,135,232,93,86,19,198,1,101,231,65,69,239,223,129,93,68,195,21,244,214,206,204,21,25,240,37,128,29,95,92,36,185,152,75,105,61,24,
68,53,59,111,92,21,37,251,119,126,188,180,1,211,192,88,43,223,193,164,8,70,188,63,184,127,69,79,172,67,226,103,7,248,65,120,55,184,238,189,77,12,148,48,213,153,219,39,121,111,76,195,195,94,59,202,197,
194,47,8,201,216,143,115,37,115,176,235,116,1,107,66,252,157,122,238,31,250,188,151,83,100,34,199,102,98,64,197,217,186,21,249,141,28,249,161,253,128,19,74,236,27,178,176,7,210,147,237,95,14,151,9,142,
21,189,57,52,59,231,169,77,218,100,22,161,51,232,156,251,112,20,217,45,90,160,158,170,42,15,126,130,154,53,3,169,196,158,171,3,50,255,37,82,233,214,252,254,122,31,248,177,71,117,72,187,96,115,18,181,154,
14,101,245,161,241,74,146,14,216,242,220,224,143,18,109,127,223,167,83,37,118,9,69,0,223,9,91,145,76,236,73,175,61,128,235,236,192,30,80,71,188,59,29,187,23,235,158,209,189,96,196,90,42,7,77,6,160,189,
71,16,136,197,250,216,233,224,36,255,166,204,146,244,52,127,176,240,82,233,104,159,30,229,150,130,118,139,66,100,133,81,177,107,90,134,42,21,255,252,7,16,140,244,100,10,55,211,57,219,142,63,62,54,117,
17,121,115,41,155,193,167,17,163,223,107,208,246,220,50,200,248,174,72,213,124,143,175,171,139,172,136,191,233,14,157,226,88,185,222,154,30,252,160,172,161,151,4,187,34,239,27,44,220,29,43,127,254,172,
254,4,136,84,247,28,252,247,12,81,89,193,191,103,217,31,61,166,136,24,121,47,52,72,149,74,212,255,24,232,182,241,231,42,32,13,165,210,61,222,57,54,74,60,114,84,213,71,13,28,158,224,113,49,192,252,108,
123,176,63,59,230,216,140,239,130,133,189,196,98,164,54,37,58,163,205,200,222,72,219,237,59,81,201,37,154,73,36,8,238,38,37,246,98,180,198,5,158,138,51,102,0,144,170,238,188,201,95,2,4,70,214,209,160,
126,184,20,145,100,100,236,145,140,68,168,74,165,145,201,97,92,255,252,167,247,70,103,19,250,143,134,147,176,65,181,75,229,166,96,127,187,181,221,251,28,38,121,29,148,180,151,145,110,54,198,247,243,51,
229,216,131,239,251,90,179,19,73,136,108,148,60,196,127,70,142,211,19,245,70,128,231,181,91,153,253,34,13,48,218,69,218,120,241,208,193,121,112,222,152,20,201,15,54,221,248,229,214,101,100,176,235,207,
151,225,133,238,122,76,209,245,121,22,129,45,84,138,146,236,46,44,169,84,251,100,5,119,186,130,31,148,129,50,112,228,85,82,151,62,166,115,145,56,176,154,76,38,69,174,203,94,189,75,146,122,135,4,84,221,
242,30,61,206,97,225,186,112,106,18,195,56,124,237,63,21,89,1,229,3,245,2,7,83,239,170,200,115,229,83,78,218,24,117,51,175,27,232,238,201,9,236,226,111,99,212,120,249,220,169,206,100,19,81,116,154,22,
96,72,72,214,82,48,248,14,141,160,18,125,94,151,233,99,244,118,0,85,139,36,54,49,222,21,108,200,25,193,100,177,230,218,243,139,222,43,164,193,170,35,18,91,204,247,211,205,91,40,136,48,182,70,161,132,15,
153,193,55,200,53,138,188,217,64,123,76,246,169,200,60,243,253,65,104,171,40,255,194,197,243,161,129,24,48,136,76,148,252,219,209,159,175,77,134,212,190,142,1,205,219,177,30,71,41,235,176,171,35,197,203,
207,169,24,57,90,233,229,198,101,139,2,17,83,9,185,191,21,223,81,100,172,252,206,5,115,46,213,231,45,198,220,224,64,73,232,50,253,214,209,113,101,231,80,129,200,156,49,10,181,21,105,197,122,181,197,27,
141,220,138,172,123,234,94,5,84,233,79,195,175,145,63,208,58,223,236,171,25,201,110,188,202,161,186,239,60,247,188,6,246,104,44,128,140,60,234,78,201,60,189,229,96,113,114,172,123,66,227,140,127,155,53,
225,104,128,29,159,236,15,174,28,159,172,29,76,102,172,207,12,88,115,104,95,140,253,105,109,69,14,28,234,60,166,255,175,251,217,90,185,209,112,149,86,240,181,90,16,201,22,105,195,79,181,67,21,122,138,
119,172,79,151,126,220,191,36,25,167,82,43,64,220,237,54,48,201,158,99,95,34,244,195,176,14,233,234,149,1,135,75,4,121,3,163,119,247,249,144,67,156,85,13,236,72,103,250,6,132,205,154,1,193,72,134,162,
18,39,42,190,137,193,254,228,34,242,205,92,243,3,215,98,179,97,18,37,132,86,85,195,135,138,135,131,214,113,159,22,181,3,59,77,62,81,32,37,27,52,97,223,167,200,28,233,247,144,176,198,211,243,37,182,66,
125,102,134,79,226,240,18,39,214,147,1,3,102,39,73,171,81,141,86,19,164,122,113,186,240,218,123,135,244,132,164,26,244,131,227,6,44,250,207,102,142,145,9,153,191,18,197,72,140,57,171,190,241,177,179,255,
43,18,70,174,88,228,245,193,46,177,55,221,255,21,161,144,113,169,139,28,10,116,126,3,93,86,158,65,166,13,43,65,241,222,97,79,8,187,253,121,165,48,9,151,112,81,106,123,82,118,213,174,10,130,73,66,136,89,
194,230,188,21,145,198,129,114,42,206,56,11,9,88,73,21,255,15,234,141,166,160,33,174,174,249,0,0,0,0,73,69,78,68,174,66,96,130,0,0};

const char* tabbed_editor::scratches_png = (const char*) resource_tabbed_editor_scratches_png;
const int tabbed_editor::scratches_pngSize = 19430;
